<?php
/*
Plugin Name: GamePress - The Game Database Plugin
Description: You can create a large game database with this plugin. It allows you to present all the details about a game such as developers, publishers, credits and genre etc.
Version: 1.1.0
Author: Kemal YAZICI / PluginPress
Author URI: http://pluginpress.net
License: GPL2
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: gamepress
*/

// If this file calls directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}
// PLUGIN DEFINES
define('GPRESS_URL',plugin_dir_url(__FILE__));
define('GPRESS_FILE', plugin_dir_path(__FILE__));
define('GPRESS_DIRECT_FILE', __FILE__);
define('GPRESS_DB_VERSION', '1.0.0');
define('GPRESS_IMG_URL', wp_upload_dir()['baseurl'].'/');
$game_press_base_url = str_replace('/',DIRECTORY_SEPARATOR,wp_upload_dir()['basedir']);
define('GPRESS_IMG_DIR',$game_press_base_url);



/************** INCLUDES ******************/

//CLASSES
require_once plugin_dir_path(__FILE__).'includes/classes/class.general.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.game.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.critic.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.people.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.chars.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.comps.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.op.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.langs.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.translate.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.jobs.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.dashboard.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.selects.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.gallery.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.templates.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.shortcodes.php';
require_once plugin_dir_path(__FILE__).'includes/classes/class.setup.php';


// HOOKS
include plugin_dir_path(__FILE__).'includes/helpers/hooks.php';

// ACTIONS
include plugin_dir_path(__FILE__).'includes/helpers/actions.php';

// FILTERS
include plugin_dir_path(__FILE__).'includes/helpers/filters.php';

//INCLUDES
include plugin_dir_path(__FILE__).'includes/helpers/shortcodes.php';
  // styles
include plugin_dir_path(__FILE__).'includes/helpers/style.php';
 // JS
include plugin_dir_path(__FILE__).'includes/helpers/js.php';

//Install
include plugin_dir_path(__FILE__).'includes/helpers/installation.php';


// Admin
include plugin_dir_path(__FILE__).'includes/admin/menus/menus.php';
include plugin_dir_path(__FILE__).'includes/admin/menus/menus.content.php';
include plugin_dir_path(__FILE__).'includes/admin/menus/menu.games.php';
include plugin_dir_path(__FILE__).'includes/admin/menus/menu.people.php';
include plugin_dir_path(__FILE__).'includes/admin/menus/menu.chars.php';
include plugin_dir_path(__FILE__).'includes/admin/menus/menu.comps.php';
include plugin_dir_path(__FILE__).'includes/admin/menus/menu.ops.php';
include plugin_dir_path(__FILE__).'includes/admin/menus/menu.langs.php';
include plugin_dir_path(__FILE__).'includes/admin/menus/menu.translate.php';
include plugin_dir_path(__FILE__).'includes/admin/menus/menu.jobs.php';
include plugin_dir_path(__FILE__).'includes/admin/menus/menu.cast.php';
include plugin_dir_path(__FILE__).'includes/admin/menus/menu.gallery.php';
include plugin_dir_path(__FILE__).'includes/admin/menus/menu.templates.php';

