<?php
if ( ! class_exists( 'WP_List_Table' ) ) {
	require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
}
class GP_Gpress_Translate_Tables extends WP_List_Table {

	public function get_lang($per_page = 50, $page_number = 1 , $search_term=""){
		global $wpdb;
		$lang = isset($_GET['translate']) ? esc_sql($_GET['translate']) : "";
		if($search_term == "") {
			$sql = "SELECT * FROM {$wpdb->prefix}gpress_content_langs WHERE lang_id=".$lang." ORDER by id DESC";

			if (!empty($_REQUEST['orderby'])) {
				$sql .= ' ORDER BY ' . esc_sql($_REQUEST['orderby']);
				$sql .= !empty($_REQUEST['order']) ? ' ' . esc_sql($_REQUEST['order']) : ' ASC';
			}


			$sql .= " LIMIT $per_page";

			$sql .= ' OFFSET ' . ($page_number - 1) * $per_page;


			$result = $wpdb->get_results($sql);
			$data = array();
			foreach ($result as $k => $r) {
				$data[$k]['id'] = $r->id;
				$data[$k]['english'] = '<a href="admin.php?page=gp-langs&translate='.$lang.'&hash='.$r->hash.'">'.$this->quote_esc($r->english).'</a>';
				$data[$k]['translation'] = '<a href="admin.php?page=gp-langs&translate='.$lang.'&hash='.$r->hash.'">'.$this->quote_esc($r->translation).'</a>';
				$data[$k]['hash'] = $r->hash;
			}
		}else{
			$sql = "SELECT * FROM ".$wpdb->prefix."gpress_content_langs WHERE lang_id=".$lang." AND (english LIKE '%".esc_sql($search_term)."%' OR translation LIKE '%".esc_sql($search_term)."%') ORDER by id LIMIT 50";
			$result = $wpdb->get_results($sql);
			$data = array();
			foreach ($result as $k => $r) {
				$data[$k]['id'] = $r->id;
				$data[$k]['english'] = '<a href="admin.php?page=gp-langs&translate='.$lang.'&hash='.$r->hash.'">'.$this->quote_esc($r->english).'</a>';
				$data[$k]['translation'] = '<a href="admin.php?page=gp-langs&translate='.$lang.'&hash='.$r->hash.'">'.$this->quote_esc($r->translation).'</a>';
				$data[$k]['hash'] = $r->hash;

			}
		}

		return $data;
	}

	function search_quote($text){
		$text = $this->quote_esc($text);
		return esc_attr($text);
	}

	function quote_esc($text){

		$text = htmlspecialchars_decode($text);

		$text = str_replace("\\'","'",$text);
		$text = str_replace('\"','"',$text);
		$text = str_replace("\&#039;","'",$text);
		$text = str_replace("&#039;","'",$text);
		return $text;
	}


	public function get_columns(){
		global $wpdb;
		$lang = isset($_GET['translate']) ? esc_sql($_GET['translate']) : "";
		$result = $wpdb->get_var('SELECT org_name FROM '.$wpdb->prefix.'gpress_langs WHERE id='.$lang);
		$tr = "English";
		if(isset($result)){
			$tr = $result;
		}
		$columns = array(
			'cb'      => '<input type="checkbox" />',
			'id'      => __('<b>ID</b>','sp'),
			'english' => __('<b>English</b>','sp'),
			'translation' => __('<b>'.$tr.'</b>','sp'),
			'hash' => __('<b>hash</b>','sp'),

		);
		return $columns;
	}

	public function prepare_items() {
		global $wpdb;
		$lang = isset($_GET['translate']) ? esc_sql($_GET['translate']) : "";
		$search_terms = isset($_POST['s']) ? sanitize_text_field(trim($_POST['s'])) : "";
		$columns = $this->get_columns();
		$hidden = array();
		$sortable = $this->get_sortable_columns();
		$this->_column_headers = array($columns, $hidden, $sortable);
		$current_page = $this->get_pagenum();
		$sql = "SELECT COUNT(id) FROM {$wpdb->prefix}gpress_content_langs WHERE lang_id=".$lang;
		$total_items = $wpdb->get_var($sql);
		$this->set_pagination_args(array(
			'total_items' => $total_items,
			'per_page' => 50
		));
		$this->items = $this->get_lang(50,$current_page, $search_terms);
	}
	public function column_default( $item, $column_name ) {
		switch( $column_name ) {
			case 'id':
			case 'english':
			case 'translation':
			case 'hash':
				return $item[ $column_name ];
			default:
				return print_r( $item, true ) ; //Show the whole array for troubleshooting purposes
		}
	}

	public function get_sortable_columns()
	{
		return array(
			"id" => array("id",true),
			"english" => array("english",false),
			"translation" => array("translation",false),
			"hash" => array("hash",false),

		);
	}

	function column_cb( $item ) {
		return sprintf(
			'<input type="checkbox" name="bulk-delete[]" value="%s" />', $item['id']
		);
	}

	public function get_bulk_actions() {
		$actions = array(
			'bulk-delete' => 'Delete'
		);

		return $actions;
	}

	public function column_name( $item ) {

		// create a nonce
		$delete_nonce = wp_create_nonce( 'sp_delete_customer' );

		$title = '<strong>' . $item['name'] . '</strong>';

		$actions = array(
			'delete' => sprintf( '<a href="?page=%s&action=%s&customer=%s&_wpnonce=%s">Delete</a>', esc_attr( $_REQUEST['page'] ), 'delete', absint( $item['id'] ), $delete_nonce )
		);

		return $title; //. $this->row_actions( $actions );
	}

	public function process_bulk_action() {

		//Detect when a bulk action is being triggered...
		if ( 'delete' === $this->current_action() ) {

			// In our file that handles the request, verify the nonce.
			$nonce = esc_attr( $_REQUEST['_wpnonce'] );

			if ( ! wp_verify_nonce( $nonce, 'sp_delete_customer' ) ) {
				die( 'Go get a life script kiddies' );
			}
			else {
				self::delete_customer( absint( $_GET['customer'] ) );

				wp_redirect( esc_url( add_query_arg() ) );
				exit;
			}

		}

		// If the delete bulk action is triggered
		if ( ( isset( $_POST['action'] ) && $_POST['action'] == 'bulk-delete' )
		     || ( isset( $_POST['action2'] ) && $_POST['action2'] == 'bulk-delete' )
		) {

			$delete_ids = esc_sql( $_POST['bulk-delete'] );

			// loop over the array of record IDs and delete them
			foreach ( $delete_ids as $id ) {
				self::delete_customer( $id );

			}

			wp_redirect( esc_url( add_query_arg() ) );
			exit;
		}
	}

	public function delete_customer( $id ) {
		global $wpdb;
		$wpdb->delete(
			"{$wpdb->prefix}gpress_content_langs",
			array( 'id' => $id ),
			array( '%d' )
		);




	}




}
