<?php
class gpress_game_comps_queries extends gp_game_general_queries{

	// BRINGS ALL COMPANIES
	function get_comps(){

		global $wpdb;
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_companies ORDER BY name');
		$comps = '<div class="gp-game-search">
            <form method="post" action="">
                <input type="text" name="comp_search" class="game_search" placeholder="'.$this->translate('Search').'...">
                <input type="submit" value="'.$this->translate('Search').'" class="search_btn">
            </form>
            </div>';
		if(!isset($_POST['comp_search'])) {
			if ( count( $result ) > 0 ) {
				foreach ( $result as $r ) {

					$comps .= '<div style="margin-right: 10px; float: left; width: 30%;margin-bottom: 10px">
                         <a href="' . home_url() . '/companies/' . $r->id . '/' . sanitize_title_with_dashes( $r->name ) . '/">' . $r->name . '</a>
                         <div class="spacer" style="clear: both;"></div>
                       </div><div class="spacer" style="clear: both;"></div>';


				}
			}
		}else{
		    $search = esc_sql($_POST['comp_search']);
			$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_companies WHERE name LIKE "%'.$search.'%" ORDER BY name');
			if(count($result)>0){
				foreach ( $result as $r ) {

					$comps .= '<div style="margin-right: 10px; float: left; width: 30%;margin-bottom: 10px">
                         <a href="' . home_url() . '/companies/' . $r->id . '/' . sanitize_title_with_dashes( $r->name ) . '/">' . $r->name . '</a>
                         <div class="spacer" style="clear: both;"></div>
                       </div><div class="spacer" style="clear: both;"></div>';


				}
            }

        }

		return $comps;
	}

	// brings company
	function get_comp($id){
		global $wpdb;
		$id = absint(esc_sql($id));
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_companies WHERE id='.$id);
		$comp = "";
		if(count($result)>0){
			foreach ($result as $r){
				$comp = $r;
			}
		}

		return $comp;
	}

	//brings companies' games
	function get_comp_games($id,$name,$page="",$limit=150){
		global $wpdb;
		$template = $this->get_temp();
		// Game info template
		$template_url = GPRESS_URL . 'includes/frontend/templates/'.$template.'/';
		$temp = $this->html_get_contents($template_url.'comps.html'); // fetch template

		$id = absint(esc_sql($id));
		$page = $page!="" ? absint(esc_sql($page)) : 1;
		$xx = $page==1 ? 0 : $limit*($page-1);
		$lim = $limit==0 ? "" : ' LIMIT '.$xx.','.$limit;
		$games = "";
		$sql = 'SELECT * FROM '.$wpdb->prefix.'gpress_content_comps WHERE com_id='.$id;
		$result = $wpdb->get_results($sql.$lim);
		if(count($result)>0){

			foreach ($result as $g){

				$r = $this->get_game($g->content_id);
				$game_link = home_url().'/games/'.$r->id.'/'.sanitize_title_with_dashes($r->title);
				// Get img

				$img = $this->get_game_image($g->content_id,'title');
				$cover = $this->img_converter($img->main, 'big');
				$visible = $cover == GPRESS_URL . 'includes/images/nocover.png' ? "visibility: visible; opacity:1" : "";


				// Total Rating
				$total_rating = round($this->cal_rate($r->id));
				$total_rating = $total_rating != "" ? $total_rating/10 : "?.?";

				//Job
				$job = $g->content_type == "title_publisher" ? "Publisher" : "Developer";
				$check = explode($game_link, $games);

				if(count($check)<2) {
					$games .= '<a href="' . $game_link . '"><div class="gp-games-item" style="background: url(' . $cover . ')">
									<div class="gp-games-overlay" style="' . $visible . '">
										<span class="gp-games-title">' . $r->title . ( $r->year > 0 ? ' (' . $r->year . ')' : '' ) . '</span>
										<span class="gp-games-title" data-id="' . $g->content_id . '">' . str_replace('{x}',$this->translate($job),$this->translate('as a {x}')) . '</span>
										<span class="gp-games-rating">' . $total_rating . '</span>
									</div>			
								</div></a>';
				}else{
					$new_job = $job == "Developer" ? "Publisher" : "Developer";
					$one = '<span class="gp-games-title" data-id="' . $g->content_id . '">' . str_replace('{x}',$this->translate($new_job),$this->translate('as a {x}')) . '</span>';
					$jobers = $this->translate('Publisher').' & '.$this->translate('Developer');
					$two = '<span class="gp-games-title" data-id="' . $g->content_id . '">' . str_replace('{x}',$this->translate($jobers),$this->translate('as {x}')) . '</span>';
					$games = str_replace($one,$two,$games);
				}

			}

			$count = $wpdb->get_results($sql);
			if(count($count)>$limit) {
				$pagination_link = home_url() . '/companies/' . $id . '/' . $name . '/';
				$pagination      = '<div class="gp-pagination">'.$this->pagination( $page, $limit, count( $count ), $pagination_link ).'</div>';

			}

		}else{
			$games .= $this->translate("There is nothing to show.");
		}

        // Company infos
        $comp = $this->get_comp($id);
		$logo = $comp->logo!="" ? '<div style="background:url('.GPRESS_URL.'includes/'.$comp->logo.') center center no-repeat; width: 200px;min-height: 200px;border:1px solid;"></div>' : "";
		$country = $comp->country!="" ? '<b>'.$this->translate('Country').': </b>'.$comp->country."<br/>" : "";
		$establish = $comp->established!="0000-00-00" ? '<b>'.$this->translate('Established').': </b>'.$this->date_converter($comp->established)."<br/>" : "";
		$website = $comp->website!="" ? '<b>'.$this->translate('Website').': </b><a href="'.$comp->website.'" target="_blank">'.$comp->website."</a><br/>" : "";
		$history = $comp->history!="" ? '<b>'.$this->translate('history').': </b>'.esc_html($comp->history) : "";
		$parent = "";
		if($comp->comp_parent!=""){
		    $par = explode('*,*',$comp->comp_parent);
		    $par_arr = array();
		    foreach ($par as $p) {
			    $pr         = explode( ":", $p );
			    $parent_url = home_url() . '/companies/' . $pr[0] . '/' . sanitize_title_with_dashes( $pr[1] ) . '/';
			    $par_arr[] = '<a href="'.$parent_url.'">'.$pr[1].'</a>';


		    }
			$parent = '<b>'.$this->translate('Parent Company').': </b>'.implode(", ",$par_arr).'<br/>';
        }

		//replaces
		$temp = str_replace('{games}',$games,$temp);
		$temp = str_replace('{logo}',$logo,$temp);
		$temp = str_replace('{country}',$country,$temp);
		$temp = str_replace('{website}',$website,$temp);
		$temp = str_replace('{parent}',$parent,$temp);
		$temp = str_replace('{history}',$this->quote_esc($history),$temp);
		$temp = str_replace('{establish}',$establish,$temp);
		$temp = str_replace('{pagination}',$pagination,$temp);

		return $temp;



	}

	function insert_comp(){
	    $id="";
	    if(isset($_POST['comp_name'])){
	        global $wpdb;
		    @$p_source=$_FILES['comp_file']['tmp_name'];
		    @$filetype=$_FILES['comp_file']['type'];
		    @$pos = strpos($filetype,'image');
		    @$logo = sanitize_text_field(trim($_POST['comp_logo']));
		    if($pos !== false){

			    @$img_name = sanitize_title_with_dashes($_POST['comp_name']).'.jpg';

			    $folder = GPRESS_FILE.'includes\/images\/companies\/';
			    $image = $folder.$img_name;
			    if(move_uploaded_file($p_source, $image)) {
				    if($_FILES['comp_file']['type']=="image/png"){
					    $this->png2jpg($image,$image,100);
				    };
				    if($_FILES['comp_file']['type']=="image/gif"){
					    $this->gif2jpg($image,$image,100);
				    }

				    $this->image_size( $image, $image, 200);
			    }

			    $logo = 'images/companies/'.$img_name;

		    }
		    @$name = sanitize_text_field(trim($_POST['comp_name']));
		    @$history = sanitize_textarea_field(trim($_POST['comp_history']));
		    @$country = sanitize_text_field(trim($_POST['comp_country']));
		    @$esta = sanitize_text_field(trim($_POST['comp_esta']));
		    $esta = $esta == "" ? 0 : $esta;
		    @$web = esc_url(trim($_POST['comp_web']));
		    $parents = isset($_POST['comp_parent']) ? $_POST['comp_parent'] : "";
		    $par = array();
		    $pr = "";
		    if($parents !="") {
			    foreach ( $parents as $k => $p ) {
				    $n         = $this->get_comp( $p );
				    $com_name  = $p . ':' . $n->name ;
				    $par[ $k ] = $com_name;
			    }
			    $pr = sanitize_text_field( implode('*,*',$par));
		    }
		    $wpdb->insert(
			    $wpdb->prefix.'gpress_companies',
			    array(
				    'name' => $name,
				    'logo' => $logo,
				    'history' => $history,
				    'established' => $esta,
				    'country' => $country,
				    'website' => $web,
				    'comp_parent' => $pr

			    )
		    );


		    $id= $wpdb->insert_id;


	    }
	    return $id;
    }

	function new_comp(){
		$logo = GPRESS_URL.'includes/images/nologo.jpg';
		$temp  =$this->html_get_contents(GPRESS_URL.'includes/admin/pages/company.html');
		$temp = str_replace('{id}','',$temp);
		$temp = str_replace('{name}','',$temp);
		$temp = str_replace('{selected_comp}','',$temp);
		$temp = str_replace('{selected-op}','',$temp);
		$temp = str_replace('{logo-url}','',$temp);
		$temp = str_replace('{logo}',$logo,$temp);
		$temp = str_replace('{establish}','',$temp);
		$temp = str_replace('{history}','',$temp);
		$temp = str_replace('{country}','',$temp);
		$temp = str_replace('{web}','',$temp);
		$temp = str_replace('{submit-button}',$this->translate('Add New'),$temp);
		$temp = str_replace('{assets}',GPRESS_URL.'includes/assets',$temp);
		$temp = str_replace('{admin}',GPRESS_URL.'includes/admin',$temp);
		$temp = str_replace('{return-url}',admin_url('admin.php?page=gp-companies'),$temp);
		$temp = str_replace('{comp-url}','',$temp);

		//Lang
		$temp = str_replace('{name:lang}',$this->translate('Name'),$temp);
		$temp = str_replace('{up-logo:lang}',$this->translate('Upload a logo'),$temp);
		$temp = str_replace('{country:lang}',$this->translate('Country'),$temp);
		$temp = str_replace('{established:lang}',$this->translate('Established'),$temp);
		$temp = str_replace('{history:lang}',$this->translate('History'),$temp);
		$temp = str_replace('{parent:lang}',$this->translate('Parent Company'),$temp);
		$temp = str_replace('{return:lang}',$this->translate('Return companies'),$temp);
		$temp = str_replace('{website:lang}',$this->translate('Website'),$temp);
		echo $temp;
		if(isset($_POST['comp_name'])){
		    $id = $this->insert_comp();
			print('<script>window.location.href="admin.php?page=gp-companies&id='.$id.'&added=added"</script>');
        }
    }

	// Edit Company Page
	function edit_comp($id){
		if(isset($_POST['comp_name'])){
			$this->update_comp();
			?>
			<div class="updated notice">
				<p><?php echo $_POST['comp_name']?> <?php echo $this->translate('has been updated.')?></p>
			</div>
			<?php
		}
		$comp = $this->get_comp($id);
		if($comp!="") {
			$logo = $comp->logo!="" ? GPRESS_IMG_URL.$comp->logo : GPRESS_URL.'includes/images/nologo.jpg';
			$parent = explode('*,*',$comp->comp_parent);
			$pr = "";
			$pr2 = "";
			foreach ($parent as $p){
			    $p = explode(':',$p);
			    $pr .= '{id:'.$p[0].',name:"'.$p[1].'"},';
			    $pr2 .= '<option value="'.$p[0].'" selected>'.$p[1].'</option>';
            }
			$temp  =$this->html_get_contents(GPRESS_URL.'includes/admin/pages/company.html');
			$temp = str_replace('{id}',$id,$temp);
			$temp = str_replace('{name}',$this->quote_esc($comp->name),$temp);
			$temp = str_replace('{selected_comp}',$pr,$temp);
			$temp = str_replace('{selected-op}',$pr2,$temp);
			$temp = str_replace('{logo-url}',$comp->logo,$temp);
			$temp = str_replace('{logo}',$logo,$temp);
			$temp = str_replace('{establish}',$comp->established,$temp);
			$temp = str_replace('{history}',$this->quote_esc($comp->history),$temp);
			$temp = str_replace('{country}',$comp->country,$temp);
			$temp = str_replace('{web}',$comp->website,$temp);
			$temp = str_replace('{submit-button}',$this->translate('Save Changes'),$temp);
			$temp = str_replace('{assets}',GPRESS_URL.'includes/assets',$temp);
			$temp = str_replace('{admin}',GPRESS_URL.'includes/admin',$temp);
			$temp = str_replace('{return-url}',admin_url('admin.php?page=gp-companies'),$temp);
			$temp = str_replace('{comp-url}',admin_url('admin.php?page=gp-companies&id='.$id),$temp);
			$temp = str_replace('{selectize-url}',admin_url('admin.php?page=gp-companies&ajax_comp_key='),$temp);

			//Lang
			$temp = str_replace('{name:lang}',$this->translate('Name'),$temp);
			$temp = str_replace('{up-logo:lang}',$this->translate('Upload a logo'),$temp);
			$temp = str_replace('{country:lang}',$this->translate('Country'),$temp);
			$temp = str_replace('{established:lang}',$this->translate('Established'),$temp);
			$temp = str_replace('{history:lang}',$this->translate('History'),$temp);
			$temp = str_replace('{parent:lang}',$this->translate('Parent Company'),$temp);
			$temp = str_replace('{return:lang}',$this->translate('Return companies'),$temp);
			$temp = str_replace('{website:lang}',$this->translate('Website'),$temp);



			echo $temp;


			if(@$_GET['added']=="added"){
				?>
				<div class="updated notice">
					<p><?php echo $comp->name.' '.$this->translate('has been added.')?></p>
				</div>
				<?php
			}
		}
	}

	// Update company info
	function update_comp(){
	    global $wpdb;
	    if(isset($_POST['comp_name'])){
		    @$p_source=$_FILES['comp_file']['tmp_name'];
		    @$filetype=$_FILES['comp_file']['type'];
		    @$pos = strpos($filetype,'image');
		    @$logo = sanitize_text_field(trim($_POST['comp_logo']));
		    if($pos !== false){

		            @$img_name = sanitize_title_with_dashes($_POST['comp_name']).'.jpg';

		            $folder = GPRESS_IMG_DIR.'\/images\/companies\/';
		            $image = $folder.$img_name;
		            if(move_uploaded_file($p_source, $image)) {
			            if($_FILES['comp_file']['type']=="image/png"){
				            $this->png2jpg($image,$image,100);
                        };
			            if($_FILES['comp_file']['type']=="image/gif"){
				            $this->gif2jpg($image,$image,100);
                        }

			            $this->image_size( $image, $image, 200);
		            }

		            $logo = 'images/companies/'.$img_name;

            }

		    @$name = sanitize_text_field(trim($_POST['comp_name']));
		    @$history = sanitize_textarea_field(trim($_POST['comp_history']));
		    @$country = sanitize_text_field(trim($_POST['comp_country']));
		    @$esta = sanitize_text_field(trim($_POST['comp_esta']));
		    $esta = $esta == "" ? 0 : $esta;
		    @$id = sanitize_text_field(trim($_POST['comp_id']));
		    @$web = esc_url(trim($_POST['comp_web']));
		    $parents = isset($_POST['comp_parent']) ? $_POST['comp_parent'] : "";
		    $par = array();
		    $pr = "";
		    if($parents !="") {
			    foreach ( $parents as $k => $p ) {
				    $n         = $this->get_comp( $p );
				    $com_name  = $p . ':' . $n->name ;
				    $par[ $k ] = $com_name;
			    }
			    $pr = sanitize_text_field( implode('*,*',$par));
		    }

		    $wpdb->update(
			    $wpdb->prefix.'gpress_companies',
			    array(
				    'name' => $name,
                    'logo' => $logo,
                    'history' => $history,
				    'established' => $esta,
                    'country' => $country,
				    'website' => $web,
                    'comp_parent' => $pr

			    ),
			    array(
				    'id'=> absint($id)
			    )
		    );


        }

    }

    // Select Companies according to a key and print as a json
    function select_comp($key){
	    global $wpdb;
	    $sql = "SELECT * FROM ".$wpdb->prefix."gpress_companies WHERE name LIKE '%".esc_sql($key)."%' ORDER by name LIMIT 50";
	    $result = $wpdb->get_results($sql);
	    $data = array();
	    if($result>0){
            $i=0;
            foreach ($result as $k => $r){
	            $data[$i]['id'] = $r->id;
	            $data[$i]['name'] = htmlspecialchars_decode($r->name);
	            $i++;
            }
        }
	    echo json_encode($data);

    }



}