<?php
class gpress_game_dashboard_queries extends gp_game_general_queries{

	function dashboard(){
		global $wpdb;
		if(isset($_POST['gp_lang'])){
			$this->save_dash_settings();
			?>
			<div class="updated notice">
				<p><?php echo $this->translate('Settings have been updated.')?></p>
			</div>
			<?php
		}
		if(isset($_POST['import-data'])){
		    $this->import_data();
        }

		@$donate = $wpdb->get_var('SELECT settings FROM '.$wpdb->prefix.'gpress_settings WHERE type="donation"');
		$donate = $donate!="" ? $donate : "1";

		$lang =$this->get_lang_settings();
		$temp = $this->get_temp();
		?>
		<form method="post" action="<?php echo admin_url('admin.php?page=gamepress')?>" novalidate="novalidate">
			<table class="form-table">
				<tr>
					<th scope="row"><label for="languages"><?php echo $this->translate('Select Language')?></label></th>
					<td><select name="gp_lang">
							<option value="default" <?php echo ($lang == "default" ? "selected" : "")?>><?php echo $this->translate('Default')?></option>
							<?php
								$get_langs = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_langs');
								if(count($get_langs)>0){
									foreach ($get_langs as $l) {
										echo '<option value="' .$l->code.'" '.($l->code == $lang ? 'selected':'').'>'.$l->org_name.'</option>';
									}
								}
							?>
						</select></td>
				</tr>
				<tr>
					<th scope="row"><label for="templates"><?php echo $this->translate('Select Frontpage Template')?></label></th>
					<td><select name="gp_temp">
							<?php
							$get_temps = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_templates');
							if(count($get_temps)>0){
								foreach ($get_temps as $t) {
									echo '<option value="' .$t->code.'" '.($t->code == $temp ? 'selected':'').'>'.$this->translate($t->name).'</option>';
								}
							}
							?>
						</select></td>
				</tr>
                <tr>
                    <th scope="row"><label for="templates"><?php echo $this->translate('Donation Message')?></label></th>
                    <td>
                        <select name="gp_donate">
                            <option value="1"<?php echo ($donate=="1" ? " selected=selected" : "")?>><?php echo $this->translate('Opened')?></option>
                            <option value="0"<?php echo ($donate=="0" ? " selected=selected" : "")?>><?php echo $this->translate('Closed')?></option>
                        </select>
                    </td>
                </tr>
			</table>
			<?php submit_button($this->translate('Save Changes'))?>
		</form>
		<?php
        if(file_exists(GPRESS_FILE.DIRECTORY_SEPARATOR.'gpress-archive.zip')){
            ?>
            <form action="<?php echo admin_url('admin.php?page=gamepress')?>" method="post">
                <p><b>it may take time to import the files, you can also open the zip file into gamepress plugin folder directly.</b></p>
                <input type="submit" value="<?php echo $this->translate('Import Data')?>" class="btn button" name="import-data" style="background: #2a2a2a;border-color: #3a3a3a;color:#fff">
            </form>
            <?php
        }

		if(file_exists(GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'count.json')){
			?>
                <a href="<?php echo admin_url('admin.php?page=gamepress&setup=1')?>" class="btn button" style="background: #2a2a2a;border-color: #3a3a3a;color:#fff"><?php echo $this->translate('Continue Setup')?></a>

			<?php
		}
		if($donate == "1") {
			?>
            <hr/>
            <p><h3>Your support will help to update this plugin and add more features. The movie database
                plugin is also on the way. If you support this plugin, some gifts will be available to you. </h3></p>
            <div id="price">
                <!--price tab-->
                <div class="plan">
                    <div class="plan-inner">
                        <div class="entry-title">
                            <h3>Silver Donator</h3>
                            <div class="price">$25<span>25 MB pack</span>
                            </div>
                        </div>
                        <div class="entry-content">
                            <ul>
                                <li>Options (158 Rows)</li>
                                <li>Engines (182 Rows)</li>
                                <li>Companies (4623 Rows)</li>
                                <li>3 Games</li>
                                <li>129 People (Credits)</li>
                                <li>36 Game Characters</li>
                                <li>103 Images</li>
                                <li>7 Videos</li>
                            </ul>
                        </div>
                        <div style="text-align: center">
                            <a href="http://www.pluginpress.net/downloads/gamepress-silver-donator-package/"
                               target="_blank"><img src="<?php echo GPRESS_URL . 'includes/images/donate.png' ?>"/></a>
                        </div>
                    </div>
                </div>
                <!-- end of price tab-->
                <!--price tab-->
                <div class="plan basic">
                    <div class="plan-inner">
                        <div class="entry-title">
                            <h3>Gold Donator</h3>
                            <div class="price">$45<span>561 MB pack</span>
                            </div>
                        </div>
                        <div class="entry-content">
                            <ul>
                                <li>Options (158 Rows)</li>
                                <li>Engines (182 Rows)</li>
                                <li>Companies (4623 Rows)</li>
                                <li><strong>56</strong> Games</li>
                                <li><strong>3793</strong> People (Credits)</li>
                                <li><strong>1077</strong> Game Characters</li>
                                <li><strong>2404</strong> Images</li>
                                <li><strong>106</strong> Videos</li>
                            </ul>
                        </div>
                        <div style="text-align: center">
                            <a href="http://www.pluginpress.net/downloads/gamepress-gold-donator-package/"
                               target="_blank"><img src="<?php echo GPRESS_URL . 'includes/images/donate.png' ?>"/></a>
                        </div>
                    </div>
                </div>
                <!-- end of price tab-->

                <!--price tab-->
                <div class="plan ultimite">
                    <div class="plan-inner">

                        <div class="entry-title">
                            <h3>Platinum Donator</h3>
                            <div class="price">$145<span>12 GB pack</span>
                            </div>
                        </div>
                        <div class="entry-content">
                            <ul>
                                <li>Options (158 Rows)</li>
                                <li>Engines (182 Rows)</li>
                                <li>Companies (4623 Rows)</li>
                                <li style="background: #000;border-bottom: 1px solid #000;color:#fff">
                                    <strong>10200</strong> Games
                                </li>
                                <li style="background: #000;border-bottom: 1px solid #000;color:#fff">
                                    <strong>91061</strong> People (Credits)
                                </li>
                                <li style="background: #000;border-bottom: 1px solid #000;color:#fff">
                                <strong>14393</strong> Game Characters</li>
                                <li style="background: #000;border-bottom: 1px solid #000;color:#fff">
                                <strong>61982</strong> Images</li>
                                <li><strong>106</strong> Videos</li>
                            </ul>
                        </div>
                        <div style="text-align: center; position: relative; margin-top: 10px">
                            <a href="http://www.pluginpress.net/downloads/gamepress-platinum-donator-package/"
                               target="_blank"><img src="<?php echo GPRESS_URL . 'includes/images/donate.png' ?>"/></a>
                        </div>
                    </div>
                </div>
                <!-- end of price tab-->
                <iframe width="560" height="315" src="https://www.youtube.com/embed/tw6wuuc5z3Y" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
            </div>

			<?php
		}

	}

	function save_dash_settings(){
		global $wpdb;
		@$lang = sanitize_text_field($_POST['gp_lang']);
		@$temp = sanitize_text_field($_POST['gp_temp']);
		@$donate = sanitize_text_field($_POST['gp_donate']);
		$count_donate = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_settings WHERE type="donation"');
		$count_lang = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_settings WHERE type="lang"');
		$count_temp = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_settings WHERE type="template"');
		if(count($count_donate)==0){
		    $wpdb->insert(
		            $wpdb->prefix.'gpress_settings',
                    array(
                            'settings' => "1",
                            'type' => "donation"
                    )
                );
        }
		if(count($count_lang)==0){
			$wpdb->insert(
				$wpdb->prefix.'gpress_settings',
				array(
					'settings' => "default",
					'type' => "lang"
				)
			);
		}
		if(count($count_temp)==0){
			$wpdb->insert(
				$wpdb->prefix.'gpress_settings',
				array(
					'settings' => "default",
					'type' => "template"
				)
			);
		}

		$wpdb->update(
			$wpdb->prefix.'gpress_settings',
			array(
				'settings' => $lang
			),
			array(
				'type'=> 'lang'
			)
		);
		$wpdb->update(
			$wpdb->prefix.'gpress_settings',
			array(
				'settings' => $temp
			),
			array(
				'type'=> 'template'
			)
		);

		$wpdb->update(
			$wpdb->prefix.'gpress_settings',
			array(
				'settings' => $donate
			),
			array(
				'type'=> 'donation'
			)
		);
		if(isset($_SESSION['gamepress_theme'] )){
			$_SESSION['gamepress_theme']  = $temp;
        }

	}

	function import_data(){
		$zip = new ZipArchive;
		$res = $zip->open(GPRESS_FILE.DIRECTORY_SEPARATOR.'gpress-archive.zip');
		if($res === TRUE){
			$zip->extractTo(GPRESS_FILE.DIRECTORY_SEPARATOR);
			$zip->close();
			unlink(GPRESS_FILE.DIRECTORY_SEPARATOR.'gpress-archive.zip');
			print('<script>window.location.href="admin.php?page=gamepress&setup=1"</script>');
        }
    }

    function setup(){
	    global $wpdb;
	    $json = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'count.json';
	    if(file_exists($json) && @$_GET['setup'] == "1"){
            $this->setup_posts();
           @$setup = $wpdb->get_var('SELECT settings FROM '.$wpdb->prefix.'gpress_settings WHERE type="file_setup"');

           ?>
            <div style="clear: both"></div>
            <div class="container">
                <div style="background-color: #2e4453; width: 50%; height: 600px; margin-top: 30px; font-family: Arial, Helvetica, sans-serif">
                    <div style="height: 530px;width: 100%;padding: 20px;position: relative; color:#ffffff;font-size: 15px;">
                        <h1 style="color:#2aebcb;font-weight: bold"><?php echo $this->translate('GamePress Setup').' '.$setup.'/4';?></h1>
					    <?php $this->setup_data($setup);?>
                    </div>
                    <div style="background: url(<?php echo GPRESS_URL.'includes/images/pluginpress.png'?>) no-repeat; background-position:top right;background-color: #3a3a3a; width: 100%; height: 70px" >
                        <a href="http://www.pluginpress.net" target="_blank" style="float: right"><div style="width: 220px;height: 70px"></div></a>
                    </div>

                </div>
            </div>
            <?php


        }
    }

    function setup_data($setup){

	    if($setup=="1"){
			echo "<br/><b>".$this->translate('This step offers a bundle of data that users need to collect.').'</b><br><br><br>';
			echo $this->translate('So, you can start importing with game options...').'<br>';
			?>
            <ul>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('Game Perspectives')?></b> (7 rows)</li>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('Game Modes')?></b> (5 rows)</li>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('Game Genres')?></b> (19 rows)</li>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('Game Themes')?></b> (41 rows)</li>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('Game Platforms')?></b> (86 rows)</li>


            </ul>
            <form action="" method="post" style="position: absolute;bottom:150px;left: 30px;">
                <input type="submit" name="submit_op" class="btn button-primary" style="background-color: #2aebcb;border-color:#2aebcb;color: #3a3a3a;text-shadow: none;font-weight: bold " value="Import&Next">
            </form>
		    <?php
        }else if($setup == "2"){
		    echo "<br/><b>".$this->translate('Next step is the game engines.').'</b><br><br>';
		    echo $this->translate('182 Game Engines Data available...').'<br>';
		    ?>
            <ul>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('Game Engines')?></b> (182 rows)</li>
            </ul>
            <img src="<?php echo GPRESS_URL.'includes/images/engines.png'?>"/>
            <form action="" method="post" style="position: absolute;bottom:130px;left: 30px;">
                <input type="submit" name="submit_engines" class="btn button-primary" style="background-color: #2aebcb;border-color:#2aebcb;color: #3a3a3a;text-shadow: none;font-weight: bold " value="Import&Next">
            </form>
		    <?php
	    }else if($setup == "3"){
		    echo "<br/><b>".$this->translate('Are you ready to import a large game companies archive?').'</b><br><br>';
		    echo $this->translate('Note: Importing this data may take some time.').'<br>';
		    ?>
            <ul>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('Game Companies')?></b> (4623 rows)</li>
            </ul>
            <img src="<?php echo GPRESS_URL.'includes/images/comps.png'?>"/>
            <form action="" method="post" style="position: absolute;bottom:130px;left: 30px;">
                <input type="submit" name="submit_comps" class="btn button-primary" style="background-color: #2aebcb;border-color:#2aebcb;color: #3a3a3a;text-shadow: none;font-weight: bold " value="Import&Next">
            </form>
		    <?php

	    }
	    else if($setup == "4"){
		    echo "<br/><b>".$this->translate('Now you can import demo game contents and see how the plugin works?').'</b><br><br>';
		    echo $this->translate('Note: Games are integrated with people, charactes, companies, and game settings.').'<br>';
		    $json = $this->html_get_contents(GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'count.json');
		    $data = json_decode($json,true);
		    $games = $data['games'];
		    $chars = $data['chars'];
		    $people = $data['people'];
		    $images = $data['images'];
		    $videos = $data['videos'];
		    $integ = $data['integ'];

		    ?>
            <ul>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('Games')?></b> (<?php echo $games?> rows)</li>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('Characters')?></b> (<?php echo $chars?> rows)</li>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('People')?></b> (<?php echo $people?> rows)</li>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('Images')?></b> (<?php echo $images?> rows)</li>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('Videos')?></b> (<?php echo $videos?> rows)</li>
                <li><i aria-hidden="true" class="dashicons dashicons-yes"></i><b><?php echo $this->translate('Game Integrations')?></b> (<?php echo $integ?> rows)</li>
            </ul>

            <form action="" method="post" style="position: absolute;bottom:130px;left: 30px;">
                <input type="submit" name="submit_games" class="btn button-primary" style="background-color: #2aebcb;border-color:#2aebcb;color: #3a3a3a;text-shadow: none;font-weight: bold " value="Finish">
            </form>
		    <?php

	    }

    }

    function setup_posts(){
	    global $wpdb;
	    if(isset($_POST['submit_op'])){
		    // PERSPECTIVES
		    $sqlperv = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress_perspectives.sql';
		    if(file_exists($sqlperv)){
			    $sqlp = $this->html_get_contents($sqlperv);
			    $sqlp = str_replace('prefix_',$wpdb->prefix,$sqlp);

			    if ( ! function_exists('dbDelta') ) {
				    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			    }
			    $wpdb->query( $sqlp );
			    unlink($sqlperv);
		    }
		    // GAME MODES
		    $sqlmodes = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress_modes.sql';
		    if(file_exists($sqlmodes)){
			    $sqlm = $this->html_get_contents($sqlmodes);
			    $sqlm = str_replace('prefix_',$wpdb->prefix,$sqlm);

			    if ( ! function_exists('dbDelta') ) {
				    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			    }
			    $wpdb->query( $sqlm );
			    unlink($sqlmodes);
		    }
		    // GAME GENRES
		    $sqlgenres = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress_genres.sql';
		    if(file_exists($sqlgenres)){
			    $sqlg = $this->html_get_contents($sqlgenres);
			    $sqlg = str_replace('prefix_',$wpdb->prefix,$sqlg);

			    if ( ! function_exists('dbDelta') ) {
				    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			    }
			    $wpdb->query($sqlg );
			    unlink($sqlgenres);
		    }
		    // GAME THEMES
		    $sqlthemes = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress_themes.sql';
		    if(file_exists($sqlthemes)){
			    $sqlt = $this->html_get_contents($sqlthemes);
			    $sqlt = str_replace('prefix_',$wpdb->prefix,$sqlt);

			    if ( ! function_exists('dbDelta') ) {
				    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			    }
			    $wpdb->query( $sqlt );
			    unlink($sqlthemes);
		    }
		    // GAME PLATFORMS
		    $sqlplatforms = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress_platforms.sql';
		    if(file_exists($sqlplatforms)){
			    $sqlpl = $this->html_get_contents($sqlplatforms);
			    $sqlpl = str_replace('prefix_',$wpdb->prefix,$sqlpl);

			    if ( ! function_exists('dbDelta') ) {
				    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			    }
			    $wpdb->query( $sqlpl );
			    unlink($sqlplatforms);
		    }


		    $wpdb->update($wpdb->prefix.'gpress_settings',
			    array(
				    'settings' => "2",
			    ),
			    array(
				    'type' => 'file_setup'
			    )
		    );

	    } else if(isset($_POST['submit_engines'])){
		    $engines = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress_engines.sql';
		    $wpdb->update($wpdb->prefix.'gpress_settings',
			    array(
				    'settings' => "3",
			    ),
			    array(
				    'type' => 'file_setup'
			    )
		    );

		    $this->import_data_sql($engines);


		    $png = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'images'.DIRECTORY_SEPARATOR.'engines.png';
		    if(file_exists($png)){
			    unlink($png);
		    }
		    if(file_exists($engines)){
			    unlink($engines);
		    }


	    }
	    else if(isset($_POST['submit_comps'])){
		    $companies = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress_companies.sql';
		    $wpdb->update($wpdb->prefix.'gpress_settings',
			    array(
				    'settings' => "4",
			    ),
			    array(
				    'type' => 'file_setup'
			    )
		    );
		    $this->import_data_sql($companies);
		    $png = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'images'.DIRECTORY_SEPARATOR.'comps.png';
		    if(file_exists($png)){
			    unlink($png);
		    }
		    if(file_exists($companies)){
			    unlink($companies);
		    }


	    }
	    else if(isset($_POST['submit_games'])){
		    $games = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress.sql';
		    $wpdb->update($wpdb->prefix.'gpress_settings',
			    array(
				    'settings' => "1",
			    ),
			    array(
				    'type' => 'file_setup'
			    )
		    );
		    $this->import_data_sql($games);

		    if(file_exists($games)){
			    unlink($games);
		    }
		    $count = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'count.json';
		    if(file_exists($count)){
			    unlink($count);
		    }

		    $sqldir = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql';

		    if(is_dir($sqldir)){
			    rmdir($sqldir);
		    }

		    print('<script>window.location.href="admin.php?page=gamepress&ready=true"</script>');

	    }
    }

    function import_data_sql($sql){
	    global $wpdb;
	    $query = '';
	    $sqlScript = file($sql);
	    foreach ($sqlScript as $line)	{
		    $startWith = substr(trim($line), 0 ,2);
		    $endWith = substr(trim($line), -1 ,1);

		    if (empty($line) || $startWith == '--' || $startWith == '/*' || $startWith == '//') {
			    continue;
		    }

		    $query = $query . $line;
		    if ($endWith == ';') {
			    $query = str_replace('prefix_',$wpdb->prefix,$query);
			    $wpdb->query($query);
			    $query= '';
		    }
	    }
    }


}