<?php
class gpress_game_detail_queries extends gp_game_general_queries {

	/************************ ALL GAMES FRONTEND TEMPLATE***************************/

	function games_template($page="",$limit=40){
		global $wpdb;
		$template = $this->get_temp();
		// Game info template
		$template_url = GPRESS_URL . 'includes/frontend/templates/'.$template.'/';
		$temp = $this->html_get_contents($template_url.'games.html'); // fetch template

		// Pagination sql settings
		$page = $page!="" ? absint(esc_sql($page)) : 1;
		$xx = $page==1 ? 0 : $limit*($page-1);
		$lim = $limit==0 ? "" : ' LIMIT '.$xx.','.$limit;

		// Variables
		$games = "";

		// If user does not search anything
		if(!isset($_POST['game_search'])) {
			$sql = 'SELECT * FROM ' . $wpdb->prefix . 'gpress_content_images WHERE is_main=1 AND content_type="title" ORDER BY id DESC';
			$result = $wpdb->get_results( $sql . $lim );
			// If user does on a valid page
			if ( count( $result ) > 0 ) {
				foreach ( $result as $g ) {
					$r = $this->get_game($g->content_id);
					$game_link = home_url().'/games/'.$r->id.'/'.sanitize_title_with_dashes($this->quote_esc($r->title));
					// Get img

					$cover = $this->img_converter($g, 'big');


					// Total Rating
					$total_rating = round($this->cal_rate($r->id));
					$total_rating = $total_rating != "" ? $total_rating/10 : "?.?";

					$games .= '<a href="'.$game_link.'"><div class="gp-games-item" style="background: url('.$cover.')">
									<div class="gp-games-overlay">
										<span class="gp-games-title">'.$this->quote_esc($r->title).($r->year>0 ? ' ('.$r->year.')' : '').'</span>
										<div class="gp-games-rating">'.$total_rating.'</div>
									</div>			
								</div></a>';
				}
			} else {
			// If user does not on a valid page
				$games = $this->translate("There is no content to show.");
			}
		}else{
			$search = $this->search_quote($_POST['game_search']);
			$result = $wpdb->get_results( 'SELECT * FROM ' . $wpdb->prefix . 'gpress_games WHERE title LIKE "%'.$search.'%" OR aka LIKE "%'.$search.'%" ORDER BY id DESC' );
			// If user does on a valid page
			if ( count( $result ) > 0 ) {
				foreach ( $result as $r ) {
					$game_link = home_url().'/games/'.$r->id.'/'.sanitize_title_with_dashes($this->quote_esc($r->title));
					// Get img
					$img = $this->get_game_image($r->id);
					$visible ="";
					if($img != ""){
						$cover = isset($img->main) ? $this->img_converter($img->main, 'big') : GPRESS_URL . 'includes/images/nocover.png';
					}else{
						$cover = GPRESS_URL . 'includes/images/nocover.png';
						$visible ="visibility: visible; opacity:1";
					}

					// Total Rating
					$total_rating = round($this->cal_rate($r->id));
					$total_rating = $total_rating != "" ? $total_rating/10 : "?.?";

					$games .= '<a href="'.$game_link.'"><div class="gp-games-item" style="background: url('.$cover.')">
									<div class="gp-games-overlay" style="'.$visible.'">
										<span class="gp-games-title">'.$this->quote_esc($r->title).($r->year>0 ? ' ('.$r->year.')' : '').'</span>
										<span class="gp-games-rating">'.$total_rating.'</span>
									</div>			
								</div></a>';
				}
			} else {
				// If user does not on a valid page
				$games = $this->translate("There is no any result.").$search;
			}

		}


		//PAGINATION
		if(isset($sql)){
			$count = $wpdb->get_results($sql);
			$pagination_link = home_url().'/games/page-';
			$pagination = $this->pagination($page,$limit,count($count),$pagination_link);

		}

		// Replaces
		$temp = str_replace('{games}',$games,$temp);
		$temp = str_replace('{pagination}',$pagination,$temp);
		$temp = str_replace('{search}',$this->translate('Search'),$temp);

		return $temp;



	}


	/*********************** GAME INFO FRONTEND TEMPLATE ****************************/
	function game_template($id,$game,$cat=""){
		global $wpdb;
		$id = absint($id);

		// trues falses
		$rating_login = "true";

		// Check login

		if (is_user_logged_in()){

			$rating_login = "false";

		}

		//Main game ural
		$title_url = home_url().'/games/'.$id.'/'.sanitize_title_with_dashes($game->title).'/';
		$template = $this->get_temp();

		// Get img
		$img = $this->get_game_image($id);
		if($img != ""){
			$cover = isset($img->main) ? $this->img_converter($img->main, 'big') : GPRESS_URL . 'includes/images/nocover.png';
			$header = isset($img->img) ? $this->select_header($img->img) : GPRESS_URL . 'includes/images/noheader.jpg';
		}else{
			$cover = GPRESS_URL . 'includes/images/nocover.png';
			$header = GPRESS_URL . 'includes/images/noheader.jpg';
		}

		// Blank cover
		$cover_blank = GPRESS_URL . 'includes/images/cover_blank.png';

		// ORG cover
		$cover_big = str_replace('_big','',$cover);
		$cover_big_tag = $this->get_img_tags($img->main->img_id);

		// get year
		$year = $game->year > 0 ? ' <span class="year">('.$game->year.')</span>' : '';

		// get platorms
		$plats = $this->get_op($id,'platform','<br/>');
		$plats = $plats != "" ? $plats : "---";
		$plats_comma = str_replace('<br/>',', ', $plats);
		$plats_break = str_replace('<br/>',' | ', $plats);

		// get perspectives
		$pers = $this->get_op($id,'perspective','<br/>');
		$pers = $pers != "" ? $pers : "---";
		$pers_comma = str_replace('<br/>',', ', $pers);
		$pers_break = str_replace('<br/>',' | ', $pers);
		// get engines
		$engine = $this->get_op($id,'engine','<br/>');
		$engine = $engine != "" ? $engine : "---";
		$engine_comma = str_replace('<br/>',', ', $engine);
		$engine_break = str_replace('<br/>',' | ', $engine);

		//get themes
		$themes = $this->get_op($id,'theme','<br/>');
		$themes_comma = str_replace('<br/>',', ', $themes);
		$themes_break = str_replace('<br/>',' | ', $themes);

		//get genres
		$genre = $this->get_op($id,'genre',', ')!="" ? $this->get_op($id,'genre','<br/>') : "----"; // get gemre
		$genre_comma = str_replace('<br/>',', ', $genre);
		$genre_comma = str_replace('----','', $genre_comma);
		$genre_break = str_replace('<br/>',' | ', $genre);
		$genre_break = str_replace('----','', $genre_break);

		//modes
		$mode = $this->get_op($id,'mode','<br/>') != "" ? $this->get_op($id,'mode','<br/>') : "----"; // get modes
		$mode_comma = str_replace('<br/>',', ', $mode);
		$mode_break = str_replace('<br/>',' | ', $mode);

		//Publishers
		$pubs = $this->get_comp($id,'publisher','<br/>') != "" ? $this->get_comp($id,'publisher','<br/>') : "----"; // get publisher
		$pubs_comma = str_replace('<br/>',', ', $pubs);
		$pubs_break = str_replace('<br/>',' | ', $pubs);

		//Developers
		$dev = $this->get_comp($id,'developer','<br/>') != "" ? $this->get_comp($id,'developer','<br/>') : "----"; // get developer
		$dev_comma = str_replace('<br/>',', ', $dev);
		$dev_break = str_replace('<br/>',' | ', $dev);



		// Game info template
		$template_url = GPRESS_URL . 'includes/frontend/templates/'.$template.'/';


		$temp = $this->html_get_contents($template_url.'game_info.html'); // fetch template

		//get user rating
		 $user_rating = $this->get_my_rating($id);

		 $total_rating = $this->cal_rate($id);
		 $total_rating = $total_rating==0 ? "N" : $total_rating;


		 $t_rating_mobile = $total_rating=="N" ? "?" : $total_rating/10;
		 $temp = str_replace("{total-rating-mobile}",$t_rating_mobile, $temp); //rating replace





		/**** Teplate replaces ****/
		if($total_rating !=""){
			$temp = str_replace("{total-rating}",$total_rating, $temp); //rating replace
			$temp = str_replace("{total-rating-display}",'', $temp); //rating replace
		}else{
			$temp = str_replace("{total-rating-display}",'display:none !important;', $temp); //rating replace
		}

		if($cat!=""){
			$temp = str_replace("{star-rating-display}","display:none !important;", $temp);//star-rating
		}else{
			$temp = str_replace("{star-rating-display}","", $temp);//star-rating
		}

		$temp = str_replace("{rating_login}",$rating_login, $temp); //header replace
		$temp = str_replace("{user-rating}",$user_rating, $temp); //header replace
		$temp = str_replace("{plugin-url}",GPRESS_URL, $temp);
		$temp = str_replace("{header}",$header, $temp); //header replace
		$temp = str_replace("{aka}",$this->quote_esc($game->aka), $temp);
		$temp = str_replace("{gp-game-id}",$id, $temp);
		$temp = str_replace("{themes}",$themes, $temp); //themes replace
		$temp = str_replace("{themes:break}",$themes_break, $temp); //themes replace
		$temp = str_replace("{themes:comma}",$themes_comma, $temp); //themes replace
		$temp = str_replace("{cover}",$cover, $temp); //cover replace
		$temp = str_replace("{cover_big}",$cover_big, $temp); //cover big replace
		$temp = str_replace("{cover_big_tag}",$cover_big_tag->titles.$cover_big_tag->people.$cover_big_tag->chars, $temp); //cover big tags replace
		$temp = str_replace("{cover_blank}",$cover_blank, $temp); //cover blank replace
		$temp = str_replace("{title}",$this->quote_esc($game->title).$year, $temp); //title replace
		$temp = str_replace("{title2}",esc_html($this->quote_esc($game->title)), $temp); //title 2 for a href alts replace
		$temp = str_replace("{plats}",$plats, $temp); // platforms replace
		$temp = str_replace("{plats:comma}",$plats_comma, $temp); // platforms replace
		$temp = str_replace("{plats:break}",$plats_break, $temp); // platforms replace
		$release = $this->date_converter($game->released) == "00 00 0000" ? "--.--.--" : $this->date_converter($game->released); //release year variable
		$temp = str_replace("{release}",$release, $temp); // release year
		$temp = str_replace("{template_url}",$template_url, $temp); // template url replace
		$temp = str_replace("{publisher}",$pubs, $temp); // publisher replace
		$temp = str_replace("{publisher:comma}",$pubs_comma, $temp); // publisher replace
		$temp = str_replace("{publisher:break}",$pubs_break, $temp); // publisher replace
		$temp = str_replace("{developer}",$dev, $temp); // developer replace
		$temp = str_replace("{developer:comma}",$dev_comma, $temp); // developer replace
		$temp = str_replace("{developer:break}",$dev_break, $temp); // developer replace
		$temp = str_replace("{genre}",$genre, $temp); // genre replace
		$temp = str_replace("{genre:comma}",$genre_comma, $temp); // genre replace
		$temp = str_replace("{genre:break}",$genre_break, $temp); // genre replace
		$temp = str_replace("{mode}",$mode, $temp); // mode replace
		$temp = str_replace("{mode:comma}",$mode_comma, $temp); // mode replace
		$temp = str_replace("{mode:break}",$mode_break, $temp); // mode replace
		$temp = str_replace("{perspective}",$pers, $temp); // perspective replace
		$temp = str_replace("{perspective:comma}",$pers_comma, $temp); // perspective replace
		$temp = str_replace("{perspective:break}",$pers_break, $temp); // perspective replace
		$temp = str_replace("{engine}",$engine, $temp); // engine replace
		$temp = str_replace("{engine:comma}",$engine_comma, $temp); // engine replace
		$temp = str_replace("{engine:break}",$engine_break, $temp); // engine replace
		//MENU Replaces
		$mymenu = $cat !="" ? '{menu-'.$cat.'}' : '{menu-general}';
		$temp = str_replace($mymenu,'gp-menu-selected',$temp);
		$temp = str_replace('{general_url}',$title_url,$temp);
		$temp = str_replace('{gallery_url}',$title_url.'gallery/',$temp);
		$temp = str_replace('{videos_url}',$title_url.'videos/',$temp);
		$temp = str_replace('{news_url}',$title_url.'news/',$temp);
		$temp = str_replace('{reviews_url}',$title_url.'reviews/',$temp);
		$temp = str_replace('{credits_url}',$title_url.'credits/',$temp);

		// Language replaces
		$temp = str_replace("{gallery:lang}",$this->translate('Gallery'), $temp); // lang replaces
		$temp = str_replace("{videos:lang}",$this->translate('Videos'), $temp); // lang replaces
		$temp = str_replace("{reviews:lang}",$this->translate('Reviews'), $temp); // lang replaces
		$temp = str_replace("{news:lang}",$this->translate('News'), $temp); // lang replaces
		$temp = str_replace("{credits:lang}",$this->translate('Credits'), $temp); // lang replaces
		$temp = str_replace("{general:lang}",$this->translate('General'), $temp); // lang replaces
		$temp = str_replace("{releasedate:lang}",$this->translate('Release date'), $temp); // lang replaces
		$temp = str_replace("{themes:lang}",$this->translate('Themes'), $temp); // lang replaces
		$temp = str_replace("{plats:lang}",$this->translate('Platforms'), $temp); // lang replaces
		$temp = str_replace("{modes:lang}",$this->translate('Modes'), $temp); // lang replaces
		$temp = str_replace("{pers:lang}",$this->translate('Perspectives'), $temp); // lang replaces
		$temp = str_replace("{engine:lang}",$this->translate('Game Engines'), $temp); // lang replaces
		$temp = str_replace("{critics:lang}",$this->translate('Critics'), $temp); // lang replaces
		$temp = str_replace("{rating:lang}",$this->translate('Rating'), $temp); // lang replaces
		$temp = str_replace("{dev:lang}",$this->translate('Developers'), $temp); // lang replaces
		$temp = str_replace("{pub:lang}",$this->translate('Publishers'), $temp); // lang replaces
		$temp = str_replace("{genres:lang}",$this->translate('Genres'), $temp); // lang replaces
		$temp = str_replace("{next}",$this->translate('Next'), $temp); // lang replaces
		$temp = str_replace("{back}",$this->translate('Back'), $temp); // lang replaces





		/**********************************MAIN PAGE***************************/
		$temp = $cat== "" ? str_replace("{sum}",'<div class="sum"><b>'.$this->translate('Summary').': </b>'.$this->quote_esc($game->sum).'</div>', $temp) : str_replace("{sum}",'', $temp);
		$director = $cat =="" || $cat =="credits" ? ($cat =="credits" ? $this->bring_crew($id,1) : $this->bring_crew($id,1,4) ) : "";
		$directors = $director != "" ? '<span class="crew"><b>'.$this->translate('Game Directors').': </b>'.$director.'</span>' : "";
		$book = $cat =="" || $cat =="credits" ? ($cat =="credits" ? $this->bring_crew($id,2) : $this->bring_crew($id,2,4) ) : "";
		$books = $book != "" ? '<span class="crew"><b>'.$this->translate('Book Writer').': </b>'.$book.'</span>' : "";
		$writer = $cat =="" || $cat =="credits" ? ($cat =="credits" ? $this->bring_crew($id,4) : $this->bring_crew($id,4,4) ) : "";
		$writers = $writer != "" ? '<span class="crew"><b>'.$this->translate('Writers').': </b>'.$writer.'</span>' : "";
		$creator = $cat =="" || $cat =="credits" ? ($cat =="credits" ? $this->bring_crew($id,3) : $this->bring_crew($id,3,4) ) : "";
		$creators = $creator != "" ? '<span class="crew"><b>'.$this->translate('Creators').': </b>'.$creator.'</span>' : "";
		$star = $cat =="" ? $this->bring_crew($id,15) : "";
		$stars = $star != "" ? '<span class="crew"><b>'.$this->translate('Stars').': </b>'.$star.'</span>' : "";

		$temp = str_replace("{director}",$directors, $temp);
		$temp = str_replace("{book}",$books, $temp);
		$temp = str_replace("{writer}",$writers, $temp);
		$temp = str_replace("{creator}",$creators, $temp);
		$temp = str_replace("{star}",$stars, $temp);
		$cast = $this->bring_cast($id);
		$cast_html = "";
		if($cast !="" && ($cat =="" || $cat =="credits")){
			$cast_html .= '<div class="cast"><b>'.$this->translate('Cast').'</b>';
			$icount = 0;
			foreach ($cast as $k => $c){
				$cast_class= $icount%2==0 ? " colored" : "";
				$cast_html .= '<div class="cast-item'.$cast_class.'"><div class="cast-photo"><img src="'.$this->img_converter($c->pic,'thumb','person').'"/></div><div class="cast-name">'.$c->name.'</div><div class="cast-bw">...</div><div class="cast-char">'.implode(" | ",$c->char).'</div></div>';
				$icount++;
				if($icount>15 && $cat =="" ){
					break;
				}
			}
			$cast_html .= '</div>';
		}

		$temp = str_replace("{cast}",$cast_html, $temp);
		$gal_html = "";
		//		 GALLERY
		if($img->img !="" && $cat =="") {
			$gal_html .= '<br/><div class="gp-gallery">';
			foreach ( $img->img as $k => $i ) {
				$count= $k+1;
				$img_tags = $this->get_img_tags($i->img_id);
				$gal_html .= '<div class="gp-gallery-item">
								<a href="'.$this->img_converter($i).'" class="flipLightBox2">
									<img src="' . $this->img_converter( $i, 'thumb' ) . '" alt="flipLightBox Image '.$count.'"/>
									<span>'.$img_tags->titles.$img_tags->people.$img_tags->chars.'</span>
								  </a>
							</div>';
				if ( $k > 4 ) {
					break;
				}
			}

			$gal_html .= '</div>';
			$gal_html .= '<div class="spacer" style="clear: both;"></div><hr/>';

		}




		$temp = str_replace("{gallery}",$gal_html, $temp);



		/********************* Categories *********************/
		// Gallery side
		if($cat == "gallery"){
			$gal_html = "";
			if($img->img !="") {
				$gal_html .= '<div class="gp-full-gallery">';
				foreach ( $img->img as $k => $i ) {
					$count= $k+1;
					$img_tags = $this->get_img_tags($i->img_id);
					$gal_html .= '<a href="'.$this->img_converter($i).'" class="flipLightBox2">
									<img src="' . $this->img_converter( $i, 'thumb' ) . '" alt="flipLightBox Image '.$count.'"/>
									<span>'.$img_tags->titles.$img_tags->people.$img_tags->chars.'</span>

								  </a>';

				}

				$gal_html .= '</div>';
				$gal_html .= '<div class="spacer" style="clear: both;"></div>';
			}
			$gal_html = $gal_html == "" ? $this->translate('There is no any picture yet.') : $gal_html;
			$temp = str_replace("{gallery-full}",$gal_html, $temp);
		}else{
			$temp = str_replace("{gallery-full}",'', $temp);
		}

		// Video side
		if($cat =="videos"){
			$vid_html = "";
			$videos = $this->get_game_videos($id);
			if($videos != ""){
				$vid_html .= '<div class="gp-videos">';
				foreach ($videos as $k => $v){
					$count_v = $k+1;
					$video_thumb = @getimagesize(GPRESS_IMG_URL.$v->thumb) ? GPRESS_IMG_URL.$v->thumb : GPRESS_URL.'includes/images/novideo.jpg';
					$vid_html .= '<a href="http://youtu.be/'.$v->source_id.'" class="venobox gp-video-item" style="background:url('.$video_thumb.'); background-size:cover;" data-vbtype="video"><img class="video-cover" src="'.GPRESS_URL.'includes/images/videobg.png"/><img class="video-cover-hover" src="'.GPRESS_URL.'includes/images/videobghover.png"/></a>';
				}
                $vid_html .= "</div>";
			}else{
				$vid_html = $this->translate("There is no video.");
			}
			$temp = str_replace("{videos}",$vid_html, $temp);
		}else{
			$temp = str_replace("{videos}",'', $temp);
		}

		// Trailer
		$trailer = "";
		$get_trailer = $this->rand_trailer($id);
		if($get_trailer !=""){
			$trailer = '<a href="http://youtu.be/'.$get_trailer->source_id.'" class="venobox gp-trailer" data-vbtype="video"><img class="gp-trailer-icon" src="'.$template_url.'images/trailer-icon.png"/> <span class="gp-trailer-text">'.$this->translate('Watch Trailer').'</span></a>';
		}
		$temp = str_replace("{trailer}",$trailer, $temp);

		// Credits
		$crew_other = "";
		if($cat == "credits"){
			$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_crew WHERE (job_id!=1 AND job_id!=2 AND job_id!=3 AND job_id!=4 AND job_id!=5 AND job_id!=6 AND job_id!=15) AND game_id='.$id);

			if(count($result)>0){
				$jobs = array();
				foreach ($result as $r) {
					$jobs[] = $r->job_id;
				}
				$jobs = array_unique($jobs);
				foreach ($jobs as $j){
					$crew_other .= '<span class="crew"><b>'.$this->get_job_name($j).': </b>'.$this->bring_crew($id,$j).'</span>';

				}

			}


		}
		$temp = str_replace('{crew_other}',$crew_other,$temp);
		// NEWS
		$newsarea = "";
		if($game->news!="") {
			$news_ids = explode(',',$game->news);
			rsort($news_ids);

			foreach ($news_ids as $k => $n) {
				if ( $cat == "news" ) {
					$news_back = $k%2!=0 ? ' gp-bg' : "";
					@$mypost     = get_post( $n );
					if($mypost!="") {
						$post_title = '<a href="' . get_permalink( $n ) . '">' . $mypost->post_title . '</a>';
						$post_thumb = get_the_post_thumbnail( $n, 'thumbnail' );
						$mycontent  = $this->limit_the_content( $mypost->post_content, $n, 60 );
						$gp_blog    = '<div class="gp-blog' . $news_back . '">
									<div class="gp-blog-thumb">' . $post_thumb . '</div>
									<div class="gp-blog-right">
										<div class="gp-blog-title">' . $post_title . '</div>
										<div class="gp-blog-content">' . $mycontent . '</div>
									</div>
									<div style="clear:both"></div>
								</div>';
						$gp_blog    = str_replace( ']]>', ']]&gt;', strip_shortcodes( $gp_blog ) );
						$newsarea   .= $gp_blog;
					}
				}
			}
		}else{
			$newsarea = $cat == "news" ? $this->translate("There is no any news about this content yet.") : "";
		}

		$temp = str_replace('{news-here}',$newsarea,$temp);

		// CRITICS
		$criticsarea = "";
		$crit_rates= array();
		if($game->reviews!="") {
			$critic_ids = explode(',',$game->reviews);
			rsort($critic_ids);
			foreach ($critic_ids as $k => $n) {

				$critic_back = $k%2!=0 ? ' gp-bg' : "";
				@$mypost     = get_post( $n );
				if($mypost !="") {
					$post_title = '<a href="' . get_permalink( $n ) . '">' . $mypost->post_title . '</a>';
					$post_thumb = get_the_post_thumbnail( $n, 'thumbnail' );
					$attr       = $this->shortcode_args( 'gp_critic', $mypost->post_content );

					if ( $attr['id'] == $id ) {

						$crit_rates[] = $attr['rating'];
					}

					$mycontent       = $this->limit_the_content( $mypost->post_content, $n, 60 );
					$crit_rating_now = round( $attr['rating'] * 10 );
					$gp_blog         = '<div class="gp-blog' . $critic_back . '">
								<div class="gp-blog-thumb"><div class="rate-circle-blog" data-value="' . $crit_rating_now . '" style="z-index:15"></div></div>
								<div class="gp-blog-right">
									<div class="gp-blog-title">' . $post_title . '</div>
									<div class="gp-blog-content">' . $mycontent . '</div>
								</div>
								<div style="clear:both"></div>
							</div>';
					$gp_blog         = str_replace( ']]>', ']]&gt;', strip_shortcodes( $gp_blog ) );
					if ( $cat == "reviews" ) {
						$criticsarea .= $gp_blog;

					}
				}
			}
		}else{
			$criticsarea = $cat == "reviews" ? $this->translate("There is no any review about this content yet.") : "";
		}

		$temp = str_replace('{critics-here}',$criticsarea,$temp);
		$ratio_crit ="N";
		if(count($crit_rates)>0){
			$ratio_crit = round((array_sum($crit_rates)/count($crit_rates))*10);

		}

		$temp = str_replace('{ratio-crit}',$ratio_crit,$temp);
		$ratio_crit_mobile = $ratio_crit == "N" ? "?" : $ratio_crit/10;
		$temp = str_replace('{ratio-crit-mobile}',$ratio_crit_mobile,$temp);
		$total_critic_display = $ratio_crit=="" ? "display:none" : "";
		$temp = str_replace('{total-critic-display}', $total_critic_display, $temp);

		//Displays
		$temp = $this->template_display($cat,$temp);

		/******************MAIN PAGE END *****************/



		return $temp;

	}

	// GET GAME OPS
	function get_op($id,$type,$ayrac){
		global $wpdb;
		$id = absint($id);
		$result = $wpdb->get_results('SELECT * FROM ' . $wpdb->prefix . 'gpress_op WHERE type="'.$type.'" AND game_id='.$id);
		$plats = "";
		$link = $type.'s';
		$dbase = $wpdb->prefix . 'gpress_'.$link;
		if(count($result)>0){
			$pp = array();
			foreach ($result as $r){
				$res = $wpdb->get_results('SELECT * FROM ' . $dbase . ' WHERE id='.$r->op_id);
				foreach ($res as $k => $p) {
					$url = home_url().'/'.$link.'/'.$p->id.'/'.sanitize_title_with_dashes($p->name);
					$pp[]= '<a href="'.$url.'">'.$this->translate($p->name).'</a>';
				}
			}
			$plats = implode($ayrac,$pp);
		}

		return $plats;

	}


	// BRING COMPANIES ACCORDING TO CONTENT
	function get_comp($id,$type,$ayrac){
		global $wpdb;
		$id = absint($id);
		$type = 'title_'.$type;
		$result = $wpdb->get_results('SELECT * FROM ' . $wpdb->prefix . 'gpress_content_comps WHERE content_type="'.$type.'" AND content_id='.$id);
		$plats = "";
		if(count($result)>0){
			$pp = array();
			foreach ($result as $r){
				$res = $wpdb->get_results('SELECT * FROM ' . $wpdb->prefix . 'gpress_companies WHERE id='.$r->com_id);
				foreach ($res as $k => $p) {
					$url = home_url().'/companies/'.$p->id.'/'.sanitize_title_with_dashes($p->name);
					$pp[]= '<a href="'.$url.'">'.$p->name.'</a>';
				}
			}
			$plats = implode($ayrac,$pp);
		}

		return $plats;


	}



	// BRING CREW INFO
	function bring_crew($id,$job,$limit=0){
		global $wpdb;
		$LIMIT = $limit !=0 ? ' LIMIT '.$limit : '';
		$id = absint($id);
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_crew WHERE game_id='.$id.' AND job_id='.$job.$LIMIT);
		$content = "";
		if(count($result)>0){
			$people = array();
			foreach ($result as $r){

				$person = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_people WHERE id='.$r->person_id);
				foreach ($person as $p){
					$person_url = home_url().'/people/'.$p->id.'/'.sanitize_title_with_dashes($p->name).'/';
					$people[] = '<a href="'.$person_url.'">'.$this->quote_esc($p->name).'</a>';

				}

			}

			$content = implode(', ',$people);

		}

		return $content;


	}


	// BRING CAST INFO
	function bring_cast($id){
		global $wpdb;
		$id = absint($id);
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_crew WHERE game_id='.$id.' AND (job_id=5 OR job_id=6)');
		$content = "";
		if(count($result)>0){
			$people = array();
			foreach ($result as $k => $r){

				$person = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_people WHERE id='.$r->person_id);

				foreach ($person as $p){
					$person_url = home_url().'/people/'.$p->id.'/'.sanitize_title_with_dashes($p->name).'/';
					$people[$r->person_id]['name'] = '<a href="'.$person_url.'">'.$this->quote_esc($p->name).'</a>';
					$char_url = $r->char_id > 0 ? home_url().'/characters/'.$r->char_id.'/'.sanitize_title_with_dashes($r->char_name).'/' : "";
					if(@count($people[$r->person_id]['char']) > 0){
						array_push( $people[ $r->person_id ]['char'], ( $r->char_id > 0 ? '<a href="'.$char_url.'">' . $this->quote_esc($r->char_name) . '</a>' : $this->quote_esc($r->char_name) ) );
					} else {
						$people[$r->person_id]['char'] = array(( $r->char_id > 0 ? '<a href="'.$char_url.'">' . $this->quote_esc($r->char_name) . '</a>' : $this->quote_esc($r->char_name) ));
					}
					$pic = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_content_images WHERE is_main=1 AND content_type="person" AND content_id='.$p->id);
					if(count($pic)>0){
						foreach ($pic as $pi){
							$people[$r->person_id]['pic'] = $pi;
						}
					}else{
						$people[$r->person_id]['pic'] = "";
					}

				}

			}

			$data = json_encode($people);
			$content = json_decode($data);


		}

		return $content;

	}




	// GET JOB name

	function get_job_name($id){
		global $wpdb;
		$id = absint($id);
		$name = "";
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_jobs WHERE id='.$id);
		foreach ($result as $r){
			$name = $this->translate($r->name);
		}
		return $name;
	}




	// Brings user rating
	function get_my_rating($id,$type="title"){
		$user = !is_null(get_current_user_id()) ? absint(get_current_user_id()) : "";
		$rating = "";
		if($user !=""){
			global $wpdb;
			$result = $wpdb->get_var('SELECT rating FROM '.$wpdb->prefix.'gpress_rating WHERE content_id='.$id.' AND content="'.$type.'" AND user='.$user);
			if(isset($result)){
				$rating = $result;
			}

		}

		return $rating;

	}





	// GET rand trailer
	function rand_trailer($id){
		global $wpdb;
		$id = absint($id);
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_content_videos WHERE content_type="title" AND content_id='.$id.' ORDER BY RAND() LIMIT 1');
		$output = "";
		if(count($result)>0){
			foreach ($result as $r){
				$output = $r;
			}
		}
		return $output;
	}


	/***************************ADMIN PAGE**********************************/
	// BRING COMPANIES ACCORDING TO CONTENT
	function get_comp_admin($id,$type){
		global $wpdb;
		$id = absint($id);
		$type = 'title_'.$type;
		$result = $wpdb->get_results('SELECT * FROM ' . $wpdb->prefix . 'gpress_content_comps WHERE content_type="'.$type.'" AND content_id='.$id);
		$plats = "";
		if(count($result)>0){
			$pp = array();
			foreach ($result as $r){
				$res = $wpdb->get_results('SELECT * FROM ' . $wpdb->prefix . 'gpress_companies WHERE id='.$r->com_id);
				foreach ($res as $k => $p) {
					$pp[]= '<option value="'.$p->id.'" selected="selected">'.$this->quote_esc($p->name).'</option>';
				}
			}
			$plats = implode("",$pp);
		}

		return $plats;


	}

	// GET GAME OPS
	function get_op_admin($id,$type){
		global $wpdb;
		$id = absint($id);
		$types = $type.'s';
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_'.$types);
		$html = "";
		if(count($result)>0){
			foreach ($result as $r) {
			    if($id!=0) {
				    $check    = $wpdb->get_results( 'SELECT * FROM ' . $wpdb->prefix . 'gpress_op WHERE op_id=' . $r->id . ' AND type="' . $type . '" AND game_id=' . $id );
				    $selected = count( $check ) > 0 ? 'selected="selected"' : "";
			    }else{
				    $selected ="";
                }
				$html .= '<option value="'.$r->id.'" '.$selected.'>'.$this->translate($r->name).'</option>';
			}
		}
		return $html;


	}

	// GET GAME BIG OPS
	function get_op_big_admin($id,$type){
		global $wpdb;
		$id = absint($id);
		$result = $wpdb->get_results('SELECT * FROM ' . $wpdb->prefix . 'gpress_op WHERE type="'.$type.'" AND game_id='.$id);
		$plats = "";
		$link = $type.'s';
		$dbase = $wpdb->prefix . 'gpress_'.$link;
		if(count($result)>0){
			$pp = array();
			foreach ($result as $r){
				$res = $wpdb->get_results('SELECT * FROM ' . $dbase . ' WHERE id='.$r->op_id);
				foreach ($res as $k => $p) {
					$pp[]= '<option value="'.$p->id.'" selected="selected">'.$this->translate($p->name).'</option>';
				}
			}
			$plats = implode("",$pp);
		}

		return $plats;

	}

	// Select Companies according to a key and print as a json
	function select_op($key,$type){
		global $wpdb;
		$sql = "SELECT * FROM ".$wpdb->prefix."gpress_".$type." WHERE name LIKE '%".esc_sql($key)."%' ORDER by name LIMIT 10";
		$result = $wpdb->get_results($sql);
		$data = array();
		if($result>0){
			$i=0;
			foreach ($result as $k => $r){
				$data[$i]['id'] = $r->id;
				$data[$i]['name'] = htmlspecialchars_decode($r->name);
				$i++;
			}
		}
		echo json_encode($data);

	}


	// ADD NEW GAME
    function new_game(){

	    if((@$_POST['g_title'] =="")&&(isset($_POST['game_submit']))){
		    ?>
            <div class="error notice">
                <p><?php echo $this->translate(  'You have to enter a title information.' ) ?></p>
            </div>
		    <?php
        }else if((@$_POST['g_year'] =="")&&(isset($_POST['game_submit']))){
		    ?>
            <div class="error notice">
                <p><?php echo $this->translate(  'You have to enter a year information.' ) ?></p>
            </div>
		    <?php
	    }else if(isset($_POST['game_submit'])){
	        $id = $this->insert_game();
		    print('<script>window.location.href="admin.php?page=gp-games&id='.$id.'&add=added"</script>');
        }


	    $genre = $this->get_op_admin(0,'genre');
	    $perv = $this->get_op_admin(0,'perspective');
	    $theme = $this->get_op_admin(0,'theme');
	    $mode = $this->get_op_admin(0,'mode');
	    $cover = GPRESS_URL.'includes/images/nocover.png';

	    $temp      = $this->html_get_contents( GPRESS_URL . 'includes/admin/pages/game.html' );
	    $temp = str_replace('{links}',"",$temp);
	    $temp = str_replace('{title:lang}',$this->translate('Title'),$temp);
	    $temp = str_replace('{title}',"",$temp);
	    $temp = str_replace('{aka:lang}',$this->translate('AKA'),$temp);
	    $temp = str_replace('{aka}',"",$temp);
	    $temp = str_replace('{sum:lang}',$this->translate('Summary'),$temp);
	    $temp = str_replace('{sum}',"",$temp);
	    $temp = str_replace('{cover}',$cover,$temp);
	    $temp = str_replace('{id}',"",$temp);
	    $temp = str_replace('{cover:lang}',$this->translate('Cover'),$temp);
	    $temp = str_replace('{year:lang}',$this->translate('Year'),$temp);
	    $temp = str_replace('{year}',"",$temp);
	    $temp = str_replace('{submit-button}',$this->translate('Add'),$temp);
	    $temp = str_replace('{release:lang}',$this->translate('Release Date'),$temp);
	    $temp = str_replace('{release}',"",$temp);
	    $temp = str_replace('{news:lang}',$this->translate('Enter news ids about this game.').' (43,44,121,... '.$this->translate('etc.').')',$temp);
	    $temp = str_replace('{news}',"",$temp);
	    $temp = str_replace('{reviews:lang}',$this->translate('Enter review ids about this game.').' (21,42,33,... '.$this->translate('etc.').')',$temp);
	    $temp = str_replace('{reviews}',"",$temp);
	    $temp = str_replace('{up-cover:lang}',$this->translate('Upload a cover'),$temp);
	    $temp = str_replace('{return:lang}',$this->translate('Return games'),$temp);
	    $temp = str_replace('{dev:lang}',$this->translate('Developers'),$temp);
	    $temp = str_replace('{selected-dev-op}',"",$temp);
	    $temp = str_replace('{pub:lang}',$this->translate('Publishers'),$temp);
	    $temp = str_replace('{selected-pub-op}',"",$temp);
	    $temp = str_replace('{genre:lang}',$this->translate('Genres'),$temp);
	    $temp = str_replace('{selected-genre-op}',$genre,$temp);
	    $temp = str_replace('{mode:lang}',$this->translate('Modes'),$temp);
	    $temp = str_replace('{selected-mode-op}',$mode,$temp);
	    $temp = str_replace('{perv:lang}',$this->translate('Perspectives'),$temp);
	    $temp = str_replace('{selected-perv-op}',$perv,$temp);
	    $temp = str_replace('{theme:lang}',$this->translate('Themes'),$temp);
	    $temp = str_replace('{selected-theme-op}',$theme,$temp);
	    $temp = str_replace('{engine:lang}',$this->translate('Game Engines'),$temp);
	    $temp = str_replace('{selected-engine-op}',"",$temp);
	    $temp = str_replace('{plat:lang}',$this->translate('Platforms'),$temp);
	    $temp = str_replace('{selected-plat-op}',"",$temp);
	    $temp = str_replace( '{return-url}', admin_url( 'admin.php?page=gp-games' ), $temp );


	    echo $temp;


    }

    // INSERT A NEW GAME

    function insert_game(){
	    global $wpdb;
	    $id=0;
	    if(isset($_POST['g_title'])){
		    @$title = sanitize_text_field(trim($_POST['g_title']));
		    @$aka = sanitize_text_field(trim($_POST['g_aka']));
		    @$sum = sanitize_textarea_field(trim($_POST['g_sum']));
		    $year = @$_POST['g_year'] !="" ? absint(sanitize_text_field(trim($_POST['g_year']))) : 0;
		    @$release = sanitize_text_field(trim($_POST['g_rel']));
		    @$news = sanitize_text_field(trim($_POST['g_news']));
		    $news = str_replace(' ','',$news);
		    @$reviews = sanitize_text_field(trim($_POST['g_reviews']));
		    $reviews = str_replace(' ','',$reviews);
		    // Title info
		    $wpdb->insert(
			    $wpdb->prefix.'gpress_games',
			    array(
				    'title' => $title,
				    'sum' => $sum,
				    'aka' => $aka,
				    'year' => $year,
				    'released' => $release,
				    'news' => $news,
				    'reviews' => $reviews

			    )

		    );
		    $id = $wpdb->insert_id;

		    // Cover Upload
		    @$p_source=$_FILES['game_file']['tmp_name'];
		    @$filetype=$_FILES['game_file']['type'];
		    @$pos = strpos($filetype,'image');
		    if($pos !== false){
			    $date = new DateTime();
			    $uzanti = '.jpg';
			    $img_name= sha1($date->format('Y-m-d-H-i-s')."-".microtime());

			    $cr_folder = $this->create_img_file();
			    $folder = $cr_folder['folder'];
			    $image = $folder.$img_name.$uzanti;
			    $big = $folder.$img_name.'_big'.$uzanti;
			    $med = $folder.$img_name.'_med'.$uzanti;
			    $thumb =  $folder.$img_name.'_thumb'.$uzanti;
			    if(move_uploaded_file($p_source, $image)) {
				    if($_FILES['game_file']['type']=="image/png"){
					    $this->png2jpg($image,$image,100);
				    };
				    if($_FILES['game_file']['type']=="image/gif"){
					    $this->gif2jpg($image,$image,100);
				    }

				    $this->image_size( $image, $big, 270);
				    $this->image_size( $image, $med, 100);
				    $this->image_crop( $image, $thumb, 180, 180);
			    }

			    $save_folder = $cr_folder['file'];
			    $boyut= getimagesize($image);
			    $byt=$boyut[0]."x".$boyut[1];
			    $filesize=filesize($image);
			    $wpdb->insert(
				    $wpdb->prefix.'gpress_images',
				    array(
					    'name' => $img_name,
					    'img_size' => $byt,
					    'file_size' => $filesize,
					    'file' => $save_folder,
					    'file_type' => $uzanti,
					    'type' => 'profil'
				    )
			    );
			    $last_id = $wpdb->insert_id;


			    $wpdb->insert(
				    $wpdb->prefix.'gpress_content_images',
				    array(
					    'img_id' => absint($last_id),
					    'img_name' => $img_name,
					    'img_size' => $byt,
					    'file' => $save_folder,
					    'file_type' => $uzanti,
					    'type' => 'cover',
					    'content_id'=> absint($id),
					    'content_type' => "title",
					    'is_main' => absint(1)
				    )
			    );


		    }

		    // Game Devs

		    $devs = isset($_POST['dev_comp']) ? $_POST['dev_comp'] : "";
		    if($devs !="") {
			    foreach ($devs as $d){
				    $wpdb->insert(
					    $wpdb->prefix.'gpress_content_comps',
					    array(
						    'com_id' => absint($d),
						    'content_id' => $id,
						    'content_type' => 'title_developer'

					    )
				    );
			    }
		    }
		    // Game Publishers
		    $pubs = isset($_POST['pub_comp']) ? $_POST['pub_comp'] : "";
		    if($pubs !="") {
			    foreach ($pubs as $p){
				    $wpdb->insert(
					    $wpdb->prefix.'gpress_content_comps',
					    array(
						    'com_id' => absint($p),
						    'content_id' => $id,
						    'content_type' => 'title_publisher'

					    )
				    );
			    }
		    }

		    // Game options
		    $ops = array('genre','perspective','theme','mode','engine','platform');
		    foreach ($ops as $op){

			    $op_arr = isset($_POST[$op.'_op']) ? $_POST[$op.'_op'] : "";
			    if($op_arr != ""){
				    foreach ($op_arr as $o){
					    $wpdb->insert(
						    $wpdb->prefix.'gpress_op',
						    array(
							    'game_id' => $id,
							    'op_id' => absint($o),
							    'type' => $op

						    )
					    );
				    }

			    }


		    }




	    }
	    return $id;
    }



	// EDIT GAME INFO
	function edit_game($id){



		if ( isset( $_POST['g_title'] ) ) {
			$this->update_game();
			?>
			<div class="updated notice">
				<p><?php echo $this->quote_esc($_POST['g_title']) ?> <?php echo $this->translate(  'has been updated.' ) ?></p>
			</div>
			<?php
		}
		$game = $this->get_game($id);
		$get_cover = $this->get_main_img( $id, 'title' );
		$cover     = $get_cover != "" ? $get_cover : GPRESS_URL . 'includes/images/nocover.png';
		$temp      = $this->html_get_contents( GPRESS_URL . 'includes/admin/pages/game.html' );

		//replace variables
		$year = $game->year>0 ? $game->year : "";//Year

		$dev = $this->get_comp_admin($id,'developer');
		$pub = $this->get_comp_admin($id,'publisher');
		$genre = $this->get_op_admin($id,'genre');
		$perv = $this->get_op_admin($id,'perspective');
		$theme = $this->get_op_admin($id,'theme');
		$mode = $this->get_op_admin($id,'mode');
		$engine = $this->get_op_big_admin($id,'engine');
		$plat = $this->get_op_big_admin($id,'platform');
		$fp = '<p>';
		$fp .= '<a href="'.home_url('games/'.$id.'/'.sanitize_title_with_dashes($game->title)).'" target="_blank">'.$this->translate('View the content').'</a>';
		$fp .= '&nbsp;&nbsp;&nbsp;<a href="'.admin_url('admin.php?page=gp-games&id='.$id.'&cat=credits').'">'.$this->translate('Edit Credits').'</a>';
		$fp .= '&nbsp;&nbsp;&nbsp;<a href="'.admin_url('admin.php?page=gp-games&id='.$id.'&cat=credits&job_id=5').'">'.$this->translate('Edit Cast').'</a>';
		$fp .= '&nbsp;&nbsp;&nbsp;<a href="'.admin_url('admin.php?page=gp-games&id='.$id.'&cat=gallery').'">'.$this->translate('Edit Gallery').'</a>';
		$fp .= '&nbsp;&nbsp;&nbsp;<a href="'.admin_url('admin.php?page=gp-games&id='.$id.'&cat=videos').'">'.$this->translate('Edit Videos').'</a>';
        $fp .= '</p>';

		//Game info
		$temp = str_replace('{links}',$fp,$temp);
        $temp = str_replace('{title:lang}',$this->translate('Title'),$temp);
		$temp = str_replace('{title}',$this->quote_esc($game->title),$temp);
		$temp = str_replace('{aka:lang}',$this->translate('AKA'),$temp);
		$temp = str_replace('{aka}',$this->quote_esc($game->aka),$temp);
		$temp = str_replace('{sum:lang}',$this->translate('Summary'),$temp);
		$temp = str_replace('{sum}',$this->quote_esc($game->sum),$temp);
		$temp = str_replace('{cover}',$cover,$temp);
		$temp = str_replace('{id}',$id,$temp);
		$temp = str_replace('{cover:lang}',$this->translate('Cover'),$temp);
		$temp = str_replace('{year:lang}',$this->translate('Year'),$temp);
		$temp = str_replace('{year}',$year,$temp);
		$temp = str_replace('{submit-button}',$this->translate('Save Changes'),$temp);
		$temp = str_replace('{release:lang}',$this->translate('Release Date'),$temp);
		$temp = str_replace('{release}',$game->released,$temp);
		$temp = str_replace('{news:lang}',$this->translate('Enter news ids about this game.').' (43,44,121,... '.$this->translate('etc.').')',$temp);
		$temp = str_replace('{news}',$game->news,$temp);
		$temp = str_replace('{reviews:lang}',$this->translate('Enter review ids about this game.').' (21,42,33,... '.$this->translate('etc.').')',$temp);
		$temp = str_replace('{reviews}',$game->reviews,$temp);
		$temp = str_replace('{up-cover:lang}',$this->translate('Upload a cover'),$temp);
		$temp = str_replace('{return:lang}',$this->translate('Return games'),$temp);
		$temp = str_replace('{dev:lang}',$this->translate('Developers'),$temp);
		$temp = str_replace('{selected-dev-op}',$dev,$temp);
		$temp = str_replace('{pub:lang}',$this->translate('Publishers'),$temp);
		$temp = str_replace('{selected-pub-op}',$pub,$temp);
		$temp = str_replace('{genre:lang}',$this->translate('Genres'),$temp);
		$temp = str_replace('{selected-genre-op}',$genre,$temp);
		$temp = str_replace('{mode:lang}',$this->translate('Modes'),$temp);
		$temp = str_replace('{selected-mode-op}',$mode,$temp);
		$temp = str_replace('{perv:lang}',$this->translate('Perspectives'),$temp);
		$temp = str_replace('{selected-perv-op}',$perv,$temp);
		$temp = str_replace('{theme:lang}',$this->translate('Themes'),$temp);
		$temp = str_replace('{selected-theme-op}',$theme,$temp);
		$temp = str_replace('{engine:lang}',$this->translate('Game Engines'),$temp);
		$temp = str_replace('{selected-engine-op}',$engine,$temp);
		$temp = str_replace('{plat:lang}',$this->translate('Platforms'),$temp);
		$temp = str_replace('{selected-plat-op}',$plat,$temp);
		$temp = str_replace( '{return-url}', admin_url( 'admin.php?page=gp-games' ), $temp );

		if(@$_GET['add'] == "added"){
			?>
            <div class="updated notice">
                <p><?php echo $this->quote_esc($game->title)." ".$this->translate(  'has been added.' ) ?></p>
            </div>
			<?php
        }


		echo $temp;
	}

	// UPDATE GAME
	function update_game(){

		global $wpdb;
		if(isset($_POST['g_title'])){
			@$id = absint(sanitize_text_field(trim($_POST['g_id'])));
			@$title = $this->quote_slash(sanitize_text_field(trim(htmlspecialchars($_POST['g_title'], ENT_QUOTES))));
			@$aka = sanitize_text_field(trim($_POST['g_aka']));
			@$sum = sanitize_textarea_field(trim($_POST['g_sum']));
			$year = @$_POST['g_year'] !="" ? absint(sanitize_text_field(trim($_POST['g_year']))) : 0;
			@$release = sanitize_text_field(trim($_POST['g_rel']));
			@$news = sanitize_text_field(trim($_POST['g_news']));
			$news = str_replace(' ','',$news);
			@$reviews = sanitize_text_field(trim($_POST['g_reviews']));
			$reviews = str_replace(' ','',$reviews);
			// Title info
			$wpdb->update(
				$wpdb->prefix.'gpress_games',
				array(
					'title' => $title,
					'sum' => $sum,
					'aka' => $aka,
					'year' => $year,
					'released' => $release,
					'news' => $news,
					'reviews' => $reviews

				),
				array(
					'id'=> $id
				)
			);

			// Cover Upload
			@$p_source=$_FILES['game_file']['tmp_name'];
			@$filetype=$_FILES['game_file']['type'];
			@$pos = strpos($filetype,'image');
			if($pos !== false){
				$date = new DateTime();
				$uzanti = '.jpg';
				$img_name= sha1($date->format('Y-m-d-H-i-s')."-".microtime());

				$cr_folder = $this->create_img_file();
				$folder = $cr_folder['folder'];
				$image = $folder.$img_name.$uzanti;
				$big = $folder.$img_name.'_big'.$uzanti;
				$med = $folder.$img_name.'_med'.$uzanti;
				$thumb =  $folder.$img_name.'_thumb'.$uzanti;
				if(move_uploaded_file($p_source, $image)) {
					if($_FILES['game_file']['type']=="image/png"){
						$this->png2jpg($image,$image,100);
					};
					if($_FILES['game_file']['type']=="image/gif"){
						$this->gif2jpg($image,$image,100);
					}

					$this->image_size( $image, $big, 270);
					$this->image_size( $image, $med, 100);
					$this->image_crop( $image, $thumb, 180, 180);
				}

				$save_folder = $cr_folder['file'];
				$boyut= getimagesize($image);
				$byt=$boyut[0]."x".$boyut[1];
				$filesize=filesize($image);
				$wpdb->insert(
					$wpdb->prefix.'gpress_images',
					array(
						'name' => $img_name,
						'img_size' => $byt,
						'file_size' => $filesize,
						'file' => $save_folder,
						'file_type' => $uzanti,
						'type' => 'profil'
					)
				);
				$last_id = $wpdb->insert_id;

				$wpdb->update(
					$wpdb->prefix.'gpress_content_images',
					array(
						'is_main' => 0,

					),
					array(
						'content_id'=> absint($id),
						'content_type' => "title",
						'is_main' => 1
					)
				);

				$wpdb->insert(
					$wpdb->prefix.'gpress_content_images',
					array(
						'img_id' => absint($last_id),
						'img_name' => $img_name,
						'img_size' => $byt,
						'file' => $save_folder,
						'file_type' => $uzanti,
						'type' => 'cover',
						'content_id'=> absint($id),
						'content_type' => "title",
						'is_main' => absint(1)
					)
				);


			}

			// Game Devs
			$wpdb->delete(
				"{$wpdb->prefix}gpress_content_comps",
				array( 'content_id' => $id),
				array( '%d' )
			);
			$devs = isset($_POST['dev_comp']) ? $_POST['dev_comp'] : "";
			if($devs !="") {
				foreach ($devs as $d){
					$wpdb->insert(
						$wpdb->prefix.'gpress_content_comps',
						array(
							'com_id' => absint($d),
							'content_id' => $id,
							'content_type' => 'title_developer'

						)
					);
				}
			}
			// Game Publishers
			$pubs = isset($_POST['pub_comp']) ? $_POST['pub_comp'] : "";
			if($pubs !="") {
				foreach ($pubs as $p){
					$wpdb->insert(
						$wpdb->prefix.'gpress_content_comps',
						array(
							'com_id' => absint($p),
							'content_id' => $id,
							'content_type' => 'title_publisher'

						)
					);
				}
			}

			// Game options
			$ops = array('genre','perspective','theme','mode','engine','platform');
			$wpdb->delete(
				"{$wpdb->prefix}gpress_op",
				array( 'game_id' => $id),
				array( '%d' )
			);
			foreach ($ops as $op){

				$op_arr = isset($_POST[$op.'_op']) ? $_POST[$op.'_op'] : "";
				if($op_arr != ""){
					foreach ($op_arr as $o){
						$wpdb->insert(
							$wpdb->prefix.'gpress_op',
							array(
								'game_id' => $id,
								'op_id' => absint($o),
								'type' => $op

							)
						);
					}

				}


			}




		}



	}

	// JOBS
	function job_list($id){
		global $wpdb;

		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_jobs');
		echo '<h3><a href="'.admin_url('admin.php?page=gp-jobs').'">'.$this->translate('Add Job').'</a></h3>';
		foreach ($result as $r){
            $end = $r->id == 5 || $r->id == 6 ? ' <span style="font-weight:650;">('.$this->translate('Cast').')</span>' : '';
			echo '<div style="margin-bottom:5px;position:relative;display:block"><a href="'.admin_url('admin.php?page=gp-games&id='.$id.'&cat=credits&job_id='.$r->id).'">'.$this->translate($r->name).'</a>'.$end.'</div>';
		}

	}

	/******************* Credits Edit *************************/
	// BRING CREW INFO
	function bring_crew_admin($id,$job,$limit=0){
		global $wpdb;
		$LIMIT = $limit !=0 ? ' LIMIT '.$limit : '';
		$id = absint($id);
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_crew WHERE game_id='.$id.' AND job_id='.$job.$LIMIT);
		$content = "";
		if(count($result)>0){
			$people = array();
			foreach ($result as $r){

				$person = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_people WHERE id='.$r->person_id);
				foreach ($person as $p){
					$people[] = '<option value="'.$p->id.'" selected="selected">'.$this->quote_esc($p->name).'</option>';

				}

			}

			$content = implode('',$people);

		}

		return $content;


	}


	function credits_edit($id){
	    $game_id = isset($_GET['id']) ? absint($_GET['id']) : "";
	    if($game_id !="") {
		    if ( $id != 5 && $id != 6 ) {

			    $this->crew_edit($id,$game_id);
		    }
	    }

    }

    function crew_edit($id,$game_id){
	    if ( isset( $_POST['crew_submit'] ) ) {
		    $this->update_crew($id,$game_id);
		    ?>
            <div class="updated notice">
                <p><?php echo $this->translate(  'The content has been updated.' ) ?></p>
            </div>
		    <?php
	    }


	    $people = $this->bring_crew_admin($game_id,$id);
	    ?>
        <div class="game-op" style="top: 50px;position: relative">
            <h2><?php echo $this->translate($this->get_job_name($id));?></h2>
            <p>
                <?php
                $game = $this->get_game($game_id);
                echo '<a href="'.admin_url('admin.php?page=gp-games&id='.$game_id).'">'.$this->quote_esc($game->title).'</a>';
                ?>
                &nbsp;/&nbsp;<a href="<?php echo admin_url('admin.php?page=gp-games&id='.$game_id.'&cat=credits')?>"><?php echo $this->translate('Credits');?></a>
            </p>
            <form method="post" action="" enctype="multipart/form-data">
                <select name="crew_edit[]" id="crew_sel" multiple style="width: 100%">
                    <?php echo $people?>
                </select><br/><br>
                <input type="submit" value="<?php echo $this->translate('Save changes')?>" name="crew_submit" class="button button-primary">
            </form>
        </div>
	    <?php
    }

    function update_crew($job,$id){
	    global $wpdb;
	    $wpdb->delete(
		    "{$wpdb->prefix}gpress_crew",
		    array( 'game_id' => absint( $id ), 'job_id' => absint( $job ) ),
		    array( '%d' )
	    );

	    if(isset( $_POST['crew_edit'])) {
		    $people = isset($_POST['crew_edit']) ? $_POST['crew_edit'] : "";
		    if($people !="") {
			    foreach ($people as $p){
				    $wpdb->insert(
					    $wpdb->prefix.'gpress_crew',
					    array(
						    'game_id' => absint($id),
						    'job_id' => $job,
						    'person_id' => $p

					    )
				    );
			    }
		    }

	    }
    }

    function update_cast($id){
	    global $wpdb;
	    $id = absint($id);
	    $person_id = isset($_POST['person_edit']) ? absint(sanitize_text_field($_POST['person_edit'])) : "";
	    $char_id = isset($_POST['char_edit']) ? absint(sanitize_text_field($_POST['char_edit'])) : 0;
	    @$job_id = absint(sanitize_text_field($_POST['job_edit']));
	    @$char_name = sanitize_text_field($_POST['char_name']);
	    if($person_id!="") {
		    $wpdb->update(
			    $wpdb->prefix . 'gpress_crew',
			    array(
				    'person_id' => $person_id,
				    'job_id'    => $job_id,
				    'char_id'   => $char_id,
				    'char_name' => $char_name,

			    ),
			    array(
				    'id' => $id
			    )
		    );
		    ?>
            <div class="updated notice">
                <p><?php echo $this->translate(  'The content has been updated.' ) ?></p>
            </div>
		    <?php
	    }else{
	       ?>
            <div class="error notice">
                <p><?php echo $this->translate(  'You have to select an actor/actress.' ) ?></p>
            </div>
            <?php
        }


    }

    function cast_edit(){
	    global $wpdb;
	    $game_id = absint($_GET['id']);
	    $id = absint($_GET['cast_edit']);
	    if(isset($_POST['cast_submit'])){
		    $this->update_cast($id);
        }
	    $q = $wpdb->get_row('SELECT * FROM '.$wpdb->prefix.'gpress_crew WHERE (job_id=5 OR job_id=6) AND game_id='.$game_id.' AND id='.$id);
	    if($q != ""){
		    $person = $this->get_person($q->person_id);
		    $pp  = '<option value="'.$person->id.'" selected = "selected">'.$this->quote_esc($person->name).'</option>';
		    if($q->char_id>0){
		        $char = $this->get_char($q->char_id);
		        $cc = '<option value="'.$char->id.'" selected = "selected">'.$this->quote_esc($char->name).'</option>';
            }
		    ?>
            <div class="game-op" style="top: 50px;position: relative">
                <p>
				    <?php
				    $game = $this->get_game($game_id);
				    echo '<a href="'.admin_url('admin.php?page=gp-games&id='.$game_id).'">'.$game->title.'</a>';
				    ?>
                    &nbsp;/&nbsp;<a href="<?php echo admin_url('admin.php?page=gp-games&id='.$game_id.'&cat=credits&job_id=5')?>"><?php echo $this->translate('Cast');?></a>
                </p>
                <form method="post" action="" enctype="multipart/form-data">
                    <label><b><?php echo $this->translate('Actor/Actress')?>: &nbsp;</b></label><br/>
                    <select name="person_edit" id="person_sel" style="width: 40%">
                        <?php echo $pp;?>
                    </select><br/>

                    <label><b><?php echo $this->translate('Job')?>: &nbsp;</b></label><br/>
                    <select name="job_edit"  style="width: 40%">
                        <option value="6"<?php echo ($q->job_id==6 ? ' selected="selected"' : "")?>><?php echo $this->translate('Voice')?></option>
                        <option value="5"<?php echo ($q->job_id==5 ? ' selected="selected"' : "")?>><?php echo $this->translate('Actor/Actress')?></option>
                    </select><br/>
                    <br/>
                    <label><b><?php echo $this->translate('Rename character')?>: &nbsp;</b></label><br/>
                    <input type="text" value="<?php echo $q->char_name;?>" name="char_name" style="width: 40%"><br/>
                    <br/>
                    <label><b><?php echo $this->translate('Character')?>: &nbsp;</b></label><br/>
                    <select name="char_edit" id="char_sel" style="width: 40%">
	                    <?php echo $cc;?>
                    </select><br/>
                    <br>
                    <input type="submit" value="<?php echo $this->translate('Save changes')?>" name="cast_submit" class="button button-primary">
                </form>
            </div>
		    <?php
            if(@$_GET['add']=="added"){
	            ?>
                <div class="updated notice">
                    <p><?php echo $this->translate(  'The content has been added.' ) ?></p>
                </div>
	            <?php
            }
        }else{
	        echo "<h1>404</h1>";
        }

    }

    function insert_cast($game_id){
	    global $wpdb;
	    if(isset( $_POST['cast_submit'])) {
		    $person = isset($_POST['person']) ? absint(sanitize_text_field($_POST['person'])) : "";
		    @$job_id = absint($_POST['job']);
		    $char = isset($_POST['char']) ? absint($_POST['char']) : 0;
		    @$char_name = sanitize_text_field($_POST['char_name']);
		    if($person !="") {

				    $wpdb->insert(
					    $wpdb->prefix.'gpress_crew',
					    array(
						    'game_id' => absint($game_id),
						    'job_id' => $job_id,
						    'person_id' => $person,
                            'char_id' => $char,
                            'char_name' => $char_name

					    )
				    );
				    $id = $wpdb->insert_id;
			    print('<script>window.location.href="admin.php?page=gp-games&id='.$game_id.'&cat=credits&cast_edit='.$id.'&add=added"</script>');

		    }else{
		        ?>
                <div class="error notice">
                    <p><?php echo $this->translate(  'You have to select an actor/actress.' ) ?></p>
                </div>
                <?php
            }

	    }


    }
    function cast_new($game_id){
	    if(isset($_POST['cast_submit'])){
		    $this->insert_cast($game_id);

	    }
	    ?>
        <div class="game-op" style="top: 50px;position: relative">
            <p>
			    <?php
			    $game = $this->get_game($game_id);
			    echo '<a href="'.admin_url('admin.php?page=gp-games&id='.$game_id).'">'.$game->title.'</a>';
			    ?>
                &nbsp;/&nbsp;<a href="<?php echo admin_url('admin.php?page=gp-games&id='.$game_id.'&cat=credits&job_id=5')?>"><?php echo $this->translate('Cast');?></a>
            </p>
            <form method="post" action="" enctype="multipart/form-data">
                <label><b><?php echo $this->translate('Actor/Actress')?>: &nbsp;</b></label><br/>
                <select name="person" id="person_sel" style="width: 40%">
                </select><br/>

                <label><b><?php echo $this->translate('Job')?>: &nbsp;</b></label><br/>
                <select name="job"  style="width: 40%">
                    <option value="6" selected="selected"><?php echo $this->translate('Voice')?></option>
                    <option value="5"><?php echo $this->translate('Actor/Actress')?></option>
                </select><br/>
                <br/>
                <label><b><?php echo $this->translate('Rename character')?>: &nbsp;</b></label><br/>
                <input type="text" value="" name="char_name" style="width: 40%"><br/>
                <br/>
                <label><b><?php echo $this->translate('Character')?>: &nbsp;</b></label><br/>
                <select name="char" id="char_sel" style="width: 40%">
                </select><br/>
                <br>
                <input type="submit" value="<?php echo $this->translate('Add')?>" name="cast_submit" class="button button-primary">
            </form>
        </div>
	    <?php
    }

    // Game gallery
    function gallery($id){
	    if(isset($_POST['upload_pics'])){
	        $this->upload_all_images($id,'title','gallery_files');
	        ?>
            <div class="updated notice">
                <p><?php echo $this->translate(  'Pictures has been uploaded.' ) ?></p>
            </div>
            <?php

        }
	    $this->gallery_action($id);
        $img = $this->get_game_image($id);

	    ?>
        <script type="text/javascript">
            jQuery(document).ready(function () {
                $("select#gp-game-gallery").imagepicker({
                    hide_select:  true,
                });

                var container = $("select.image-picker.masonry").next("ul.thumbnails");
                container.imagesLoaded(function(){
                    container.masonry({
                        itemSelector:   "li",
                    });
                });

                $("form").submit(function() {
                    if ($('input.action-gallery').val() == "<?php echo $this->translate("Apply")?>") {
                        if($('#action-time').val()=="delete") {
                            var c = confirm("<?php echo $this->translate('Are you sure?')?>");
                            return c;
                        }
                    }
                });



            });

        </script>

        <div class="game-op" style="top: 5px;position: relative;padding:30px">
            <form method="post" action="" enctype="multipart/form-data">
                <div style="display: block">
                    <div style="float: left;">
                        <select  name="action_sel" id="action-time">
                            <option value=""><?php echo $this->translate('Action')?></option>
                            <option value="cover"><?php echo $this->translate('Make Cover')?></option>
                            <option value="go"><?php echo $this->translate('Edit Picture')?></option>
                            <option value="delete"><?php echo $this->translate('Delete')?></option>
                        </select>
                        <input type="submit" value="<?php echo $this->translate('Apply')?>" name="gallery_action" class="button button-primary action-gallery">

                    </div>
                    <div style="float: right;position: relative;margin-right: 150px">
                    <div class="upload-btn-wrapper">
                        <button class="btn"><?php echo "&#x2191; ".$this->translate('Upload Pictures')?></button>
                        <input type="file" name="gallery_files[]" multiple="multiple"/>

                    </div>
                        <input type="submit" value="<?php echo $this->translate('Save')?>" name="upload_pics" class="btn button button-primary" style="height: 35px">
                    </div>

                </div>
                <br/><br/><br/>
	    <?php

        echo '<select class="image-picker masonry show-html" id="gp-game-gallery" name="gp_gallery">';
        echo '<option value=""></option>';
        if($img!="") {
	        echo( isset( $img->main ) ? '<option data-img-src="' . $this->img_converter( $img->main, 'big' ) . '" value="' . $img->main->img_id . '" selected="selected">' . $img->main->img_id . '</option>' : '' );
	        if(isset($img->img)){
	            foreach ($img->img as $i){
	                echo '<option data-img-src="' . $this->img_converter( $i, 'big' ) . '" value="' . $i->img_id . '">' . $i->img_id . '</option>';
                }
            }
        }
        echo '</select>';
        ?>
            </form>
        </div>
        <?php

    }


    function gallery_action($id){
	    global $wpdb;
        if(isset($_POST['gallery_action'])){

            // Cover
            if(@$_POST['action_sel'] == "cover"){
                if(@$_POST['gp_gallery'] != ""){

	                @$img = absint($_POST['gp_gallery']);
	                $wpdb->update(
		                $wpdb->prefix.'gpress_content_images',
		                array(
			                'is_main' => 0,

		                ),
		                array(
			                'content_id'=> absint($id),
			                'content_type' => "title",
			                'is_main' => 1
		                )
	                );
	                $wpdb->update(
		                $wpdb->prefix.'gpress_content_images',
		                array(
			                'is_main' => 1,

		                ),
		                array(
			                'content_id'=> absint($id),
			                'content_type' => "title",
			                'img_id' => $img
		                )
	                );

	                ?>
                    <div class="updated notice">
                        <p><?php echo $this->translate(  'The cover has been changed.' ) ?></p>
                    </div>
	                <?php
                }
            }else if(@$_POST['action_sel'] == "delete"){
	            @$img = absint($_POST['gp_gallery']);
                $result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_images WHERE id='.$img);
                if(count($result)>0){
                    foreach ($result as $r){
                        $check = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_content_images WHERE is_main=1 AND img_id='.$r->id);
                        if(count($check) == 0) {
	                        $org   = GPRESS_IMG_DIR . DIRECTORY_SEPARATOR . str_replace( '/', DIRECTORY_SEPARATOR, $r->file ) . $r->name . $r->file_type;
	                        $big   = GPRESS_IMG_DIR . DIRECTORY_SEPARATOR . str_replace( '/', DIRECTORY_SEPARATOR, $r->file ) . $r->name . "_big" . $r->file_type;
	                        $med   = GPRESS_IMG_DIR . DIRECTORY_SEPARATOR . str_replace( '/', DIRECTORY_SEPARATOR, $r->file ) . $r->name . "_med" . $r->file_type;
	                        $thumb = GPRESS_IMG_DIR . DIRECTORY_SEPARATOR . str_replace( '/', DIRECTORY_SEPARATOR, $r->file ) . $r->name . "_thumb" . $r->file_type;
	                        wp_delete_file( $org );
	                        wp_delete_file( $big );
	                        wp_delete_file( $med );
	                        wp_delete_file( $thumb );

	                        $wpdb->delete(
		                        "{$wpdb->prefix}gpress_images",
		                        array( 'id' => $r->id ),
		                        array( '%d' )
	                        );
	                        $wpdb->delete(
		                        "{$wpdb->prefix}gpress_content_images",
		                        array( 'img_id' => $r->id ),
		                        array( '%d' )
	                        );
	                        ?>
                            <div class="updated notice">
                                <p><?php echo $this->translate( 'The picture has been deleted.' ) ?></p>
                            </div>
	                        <?php
                        }else{
	                        ?>
                            <div class="error notice">
                                <p><?php echo $this->translate( 'The cover pictures cannot be deleted.' ) ?></p>
                            </div>
	                        <?php
                        }

                    }
                }
            }else if(@$_POST['action_sel']=="go"){
	            $img = absint($_POST['gp_gallery']);
	            if(@$_POST['gp_gallery']!="") {
		            print( '<script>window.location.href="admin.php?page=gp-gallery&id=' . $img . '"</script>' );

	            }
            }

            //


        }

    }

    // VIDEO GALLERY
    function videos($id){
	    $game_id = isset($_GET['id']) ? absint($_GET['id']) : "";
	    if(isset($_POST['add_video']) && $game_id !=""){
	        @$video_link = $_POST['video_link'];
	        $this->save_youtube($game_id,trim($video_link));

        }
	    if(isset($_POST['del_video']) && $game_id !=""){
		    $vids = isset($_POST['youtube_videos']) ? $_POST['youtube_videos'] : "";
		    if($vids!="") {
			    foreach ( $vids as $vi ) {
				    $this->delete_youtube( absint( $vi ) );
			    }
			    ?>
                <div class="updated notice">
                    <p><?php echo $this->translate( 'The videos have been deleted.' ) ?></p>
                </div>
			    <?php
		    }
        }
	    $videos = $this->get_game_videos($id);
	    ?>
        <script type="text/javascript">
            jQuery(document).ready(function () {


                $("input#del_video").click(function() {
                    if ($('input#del_video').val() == "<?php echo $this->translate("Delete")?>") {
                            var c = confirm("<?php echo $this->translate('Are you sure?')?>");
                            return c;

                    }
                });



            });

        </script>
        <?php
	    echo "<div style='background-color:#fff;padding:15px;position:relative'>";
	    echo "<form action='' method='post'>";
	    echo '<div style="display: block;margin-bottom: 20px;position: relative">';
	    echo '<input type="text" placeholder="'.$this->translate("Add youtube link here...").'" style="width: 300px;" name="video_link">&nbsp;';
	    echo '<input type="submit" name="add_video" value="'.$this->translate('Add').'" class="btn button button-primary"/>';
	    echo ($videos != "" ? '<span style="position: absolute; right: 20px"><input type="submit" name="del_video" value="'.$this->translate('Delete').'" id="del_video" class="btn button" style="background-color: #a30a01;color:#fff;border-color: #a30a01"/></span>' :"");
	    echo '</div>';
	    if($videos != ""){
	        foreach ($videos as $v){
	            echo '<div style="padding:30px; background-color: #030205;margin-right: 10px;margin-bottom: 10px; float: left;position: relative">';
	            echo '<span style="display: block;margin-bottom: 10px;right:5px; top:5px; position: absolute"><input type="checkbox" name="youtube_videos[]" value="'.$v->video_id.'"/></span>';
	            echo '<iframe width="370" height="180" src="https://www.youtube.com/embed/'.$v->source_id.'" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>';
	            echo '</div>';
            }

        }
	    echo "</form>";
	    echo '<div style="clear: both"></div>';
	    echo "</div>";
    }



	function select_people($key){
		global $wpdb;
		$check = explode('id:',$key);
		if(count($check)<2) {

			$sql    = "SELECT id,name FROM " . $wpdb->prefix . "gpress_people WHERE LOWER(name) LIKE '%" . esc_sql( strtolower($key)) . "%' ORDER by name LIMIT 10";
			$result = $wpdb->get_results( $sql );
			$data   = array();
			if ( $result > 0 ) {
				$i = 0;
				foreach ( $result as $k => $r ) {
					$data[ $i ]['id']   = $r->id;
					$data[ $i ]['name'] = $this->quote_esc($r->name);
					$i ++;
				}
			}
			echo json_encode( $data );
		}else{
			$sql    = "SELECT id,name FROM " . $wpdb->prefix . "gpress_people WHERE id=".absint(trim($check[1]));
			$result = $wpdb->get_results( $sql );
			$data   = array();
			if ( $result > 0 ) {
				$i = 0;
				foreach ( $result as $k => $r ) {
					$data[ $i ]['id']   = $r->id;
					$data[ $i ]['name'] = $this->quote_esc($r->name);
					$i ++;
				}
			}
			echo json_encode( $data );
        }
	}

	function select_char($key){
		global $wpdb;
		$check = explode('id:',$key);
		if(count($check)<2) {
			$sql    = "SELECT id,name FROM " . $wpdb->prefix . "gpress_chars WHERE LOWER(name) LIKE '%" . esc_sql( strtolower($key) ) . "%' ORDER by name LIMIT 10";
			$result = $wpdb->get_results( $sql );
			$data   = array();
			if ( $result > 0 ) {
				$i = 0;
				foreach ( $result as $k => $r ) {
					$data[ $i ]['id']   = $r->id;
					$data[ $i ]['name'] = $this->quote_esc($r->name);
					$i ++;
				}
			}
			echo json_encode( $data );
		}else{
			$sql    = "SELECT id,name FROM " . $wpdb->prefix . "gpress_chars WHERE id=".absint(trim($check[1]));
			$result = $wpdb->get_results( $sql );
			$data   = array();
			if ( $result > 0 ) {
				$i = 0;
				foreach ( $result as $k => $r ) {
					$data[ $i ]['id']   = $r->id;
					$data[ $i ]['name'] = $this->quote_esc($r->name);
					$i ++;
				}
			}
			echo json_encode( $data );
		}
	}


	function select_game($key){
		global $wpdb;
		$check = explode('id:',$key);
		if(count($check)<2) {
			$sql    = "SELECT id,title FROM " . $wpdb->prefix . "gpress_games WHERE LOWER(title) LIKE '%" . esc_sql( strtolower($key) ) . "%' ORDER by id LIMIT 10";
			$result = $wpdb->get_results( $sql );
			$data   = array();
			if ( $result > 0 ) {
				$i = 0;
				foreach ( $result as $k => $r ) {
					$data[ $i ]['id']   = $r->id;
					$data[ $i ]['name'] = str_replace( '&#039;', "'", htmlspecialchars_decode($r->title) );
					$i ++;
				}
			}
			echo json_encode( $data );
		}else{
			$sql    = "SELECT id,title FROM " . $wpdb->prefix . "gpress_games WHERE id=".absint(trim($check[1]));
			$result = $wpdb->get_results( $sql );
			$data   = array();
			if ( $result > 0 ) {
				$i = 0;
				foreach ( $result as $k => $r ) {
					$data[ $i ]['id']   = $r->id;
					$data[ $i ]['name'] = str_replace( '&#039;', "'", htmlspecialchars_decode($r->title) );
					$i ++;
				}
			}
			echo json_encode( $data );
		}
	}

}