<?php
class gpress_game_op_queries extends gp_game_general_queries{


	function get_ops($type){

		global $wpdb;

		$ops = "";
		$type = esc_sql($type);
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_'.$type.' ORDER BY name');
		if(count($result)>0){
			foreach ($result as $r) {
				$ops .= '<div style="margin-right: 10px; float: left; width: 45%"><a href="'.home_url().'/'.$type.'/'.$r->id.'/'.sanitize_title_with_dashes($r->name).'/">'.$this->translate($r->name).'</a></div><div class="spacer" style="clear: both;"></div>';
				}
		}


		return $ops;


	}

	function get_op_name($type,$id){
		global $wpdb;
		$id = absint(esc_sql($id));
		$type = esc_sql($type);
		$result = "";
		$var = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_'.$type.' WHERE id='.$id);
		if(count($var)>0){
			foreach ($var as $v){
				$result = $v;
			}
		}
		return $result;
	}

	function get_op_games($id,$op,$page="",$name,$limit=40){

		global $wpdb;

		$template = $this->get_temp();
		// Game info template
		$template_url = GPRESS_URL . 'includes/frontend/templates/'.$template.'/';
		$temp = $this->html_get_contents($template_url.'ops.html'); // fetch template
		// Pagination sql settings
		$page = $page!="" ? absint(esc_sql($page)) : 1;
		$xx = $page==1 ? 0 : $limit*($page-1);
		$lim = $limit==0 ? "" : ' LIMIT '.$xx.','.$limit;
		$games = "";
		$sql = 'SELECT * FROM '.$wpdb->prefix.'gpress_op WHERE type="'.$op.'" AND op_id='.$id;
		$result = $wpdb->get_results($sql.$lim);
		if(count($result)>0){

			foreach ($result as $g){

				$r = $this->get_game($g->game_id);
				$game_link = home_url().'/games/'.$r->id.'/'.sanitize_title_with_dashes($r->title);
				// Get img

				$img = $this->get_game_image($g->game_id,'title');
				$cover = $this->img_converter($img->main, 'big');
				$visible = $cover == GPRESS_URL . 'includes/images/nocover.png' ? "visibility: visible; opacity:1" : "";


				// Total Rating
				$total_rating = round($this->cal_rate($r->id));
				$total_rating = $total_rating != "" ? $total_rating/10 : "?.?";

				$games .= '<a href="'.$game_link.'"><div class="gp-games-item" style="background: url('.$cover.')">
									<div class="gp-games-overlay" style="'.$visible.'">
										<span class="gp-games-title">'.$r->title.($r->year>0 ? ' ('.$r->year.')' : '').'</span>
										<span class="gp-games-rating">'.$total_rating.'</span>
									</div>			
								</div></a>';

			}

			$count = $wpdb->get_results($sql);
			if(count($count)>$limit) {
				$pagination_link = home_url() . '/' . $op . 's/' . $id . '/' . $name . '/';
				$pagination      = '<div class="gp-pagination">'.$this->pagination( $page, $limit, count( $count ), $pagination_link ).'</div>';

			}

		}else{
			$games .= $this->translate("There is nothing to show.");
		}


		//replaces
		$temp = str_replace('{games}',$games,$temp);
		$temp = str_replace('{pagination}',$pagination,$temp);

		return $temp;

	}

	//Option edit
	function op_edit($type,$id){
		if(isset($_POST['op_edit'])){
			$this->update_op();
			?>
			<div class="updated notice">
				<p><?php echo $_POST['op_edit']?> <?php echo $this->translate('has been updated.')?></p>
			</div>
			<?php
		}
		$op = $this->get_op_name($type,$id);
		if($op!="") {
			?>
			<div class="game-op" style="top: 50px;position: relative">

				<form method="post" action="<?php echo admin_url('admin.php?page=gp-ops&op='.$type.'&id='.$id)?>">
					<label><b><?php echo $this->translate('Name')?>: </b></label>
					<input type="text" name="op_edit" value="<?php echo str_replace("\'","'",$op->name)?>" style="width: 40%"/>
					<input type="hidden" name="op_type" value="<?php echo $type?>">
					<input type="hidden" name="op_id" value="<?php echo $id?>">
					<?php submit_button($this->translate('Save Changes'));?>
				</form>
				<a href="<?php echo admin_url('admin.php?page=gp-ops&op='.$type)?>"><?php echo $this->translate('Return game '.$type)?></a>
			</div>

			<?php
			if(@$_GET['added']=="added"){
				?>
				<div class="updated notice">
					<p><?php echo $op->name?> <?php echo $this->translate('has been added.')?>.</p>
				</div>
				<?php
			}
		}
	}

	//Add new option
	function op_new($type){
		$type = esc_sql($type);
		?>
		<div class="game-op" style="top: 50px;position: relative">

			<form method="post" action="">
                <label><b><?php echo $this->translate('Name')?>: </b></label>
				<input type="text" name="op_name" value="" style="width: 40%"/>
				<input type="hidden" name="op_type" value="<?php echo $type?>">
				<?php submit_button($this->translate('Add'));?>
			</form>
			<a href="<?php echo admin_url('admin.php?page=gp-ops&op='.$type)?>"><?php echo $this->translate('Return game '.$type)?></a>
		</div>

		<?php
		if(isset($_POST['op_name'])){
			$lastid= $this->insert_op();
			print('<script>window.location.href="admin.php?page=gp-ops&op='.$type.'&id='.$lastid.'&added=added"</script>');
		}
	}

	// Update game option
	function update_op(){
		global $wpdb;
		@$name = sanitize_text_field(trim($_POST['op_edit']));
		@$type = sanitize_text_field(trim($_POST['op_type']));
		@$id = sanitize_text_field(trim($_POST['op_id']));
		$wpdb->update(
			$wpdb->prefix.'gpress_'.$type,
			array(
				'name' => $name
			),
			array(
				'id'=> esc_sql($id)
			)
		);
	}

	// Insert game option
	function insert_op(){
		global $wpdb;
		@$name = sanitize_text_field(trim($_POST['op_name']));
		@$type = sanitize_text_field(trim($_POST['op_type']));
		$wpdb->insert(
			$wpdb->prefix.'gpress_'.$type,
			array(
				'name' => $name,
			)
		);
		return $wpdb->insert_id;
	}




}