<?php
class gpress_person_detail_queries extends gp_game_general_queries{

	function people_template($page="",$limit=40){

		global $wpdb;
		$template = $this->get_temp();
		// Game info template
		$template_url = GPRESS_URL . 'includes/frontend/templates/'.$template.'/';
		$temp = $this->html_get_contents($template_url.'people.html'); // fetch template

		$page = $page!="" ? absint(esc_sql($page)) : 1;
		$xx = $page==1 ? 0 : $limit*($page-1);
		$lim = $limit==0 ? "" : ' LIMIT '.$xx.','.$limit;

		$people = "";
		if(!isset($_POST['people_search'])){
			$sql = 'SELECT * FROM '.$wpdb->prefix.'gpress_content_images WHERE content_type="person" AND is_main=1 ORDER by id DESC';
			$result = $wpdb->get_results($sql.$lim);
			if(count($result)>0){
				foreach ($result as $r){

					$person = $this->get_person($r->content_id);
					$img = $this->img_converter($r,'thumb','photo');
					$people .= '<a href="'.home_url().'/people/'.$person->id.'/'.sanitize_title_with_dashes($person->name).'/"><img src="'.$img.'"/><span>'.$this->quote_esc($person->name).'</span><br/></a>';


				}


			}

		}else{
			$search = esc_attr(sanitize_text_field($_POST['people_search']));
			$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_people WHERE name LIKE "%'.$search.'%" LIMIT 100');
			if(count($result)>0){

				foreach ( $result as $r ) {

					$img = $this->get_game_image($r->id, 'person');
					$img = $this->img_converter($img->main,'thumb','person');
					$people .= '<a href="'.home_url().'/people/'.$r->id.'/'.sanitize_title_with_dashes($r->name).'/"><img src="'.$img.'"/><span>'.$this->quote_esc($r->name).'</span><br/></a>';
				}

			}else{

				$people = $this->translate("There is no any result.");
			}


		}

		if(isset($sql)){
			$count = $wpdb->get_results($sql);
			$pagination_link = home_url().'/people/page-';
			$pagination = $this->pagination($page,$limit,count($count),$pagination_link);

		}

		$temp = str_replace('{people}',$people,$temp);
		$temp = str_replace('{pagination}',$pagination,$temp);
		$temp = str_replace('{search}',$this->translate('Search'),$temp);

		return $temp;


	}

	// Person info template

	function person_template($id,$person,$cat=""){
		$template = $this->get_temp();
		$template_url = GPRESS_URL . 'includes/frontend/templates/'.$template.'/';
		$img = $this->get_game_image($id,'person');
		$photo = $this->img_converter($img->main,'','person');
		$bd = $person->birthday != "0000-00-00" && $cat =="" ? "<div class='gp-info'><b>".$this->translate('Birthday').": </b>".$this->date_converter($person->birthday).'</div>' : "";
		$dd = $person->deathday != "0000-00-00" && $cat =="" ? "<div class='gp-info'><b>".$this->translate('Died').": </b>".$this->date_converter($person->deathday).'</div>' : "";
		$bio = $person->bio != "" && $cat ==""? "<div class='gp-info'><b>".$this->translate('Biography').": </b>". strip_tags(html_entity_decode($person->bio)).'</div>' : "";
		$birth = $person->birthplace != "" && $cat ==""? "<div class='gp-info'><b>".$this->translate('Birthplace').": </b>".$person->birthplace.'</div>' : "";
		$real = $person->real_name != "" && $cat =="" ? "<div class='gp-info'><b>".$this->translate('Real name').": </b>".$person->real_name.'</div>' : "";
		$aka = $person->aka != "" && $cat =="" ? "<div class='gp-info'><b>".$this->translate('Also known as').": </b>".$person->aka.'</div>' : "";
		$zodiac = $person->zodiac!="" ? '<img src="'.$template_url.'images/zodiac/'.$person->zodiac.'.png"/><br/>'.$this->translate($person->zodiac).'<br/>&nbsp;' : "";
		$cover_big_tag = $this->get_img_tags($img->main->img_id);

		$gal_html = "";
		//		 GALLERY
		if($img->img !="" && ($cat =="" || $cat =="gallery")) {
			$gal_html .= '<br/><div class="gp-gallery">';
			$gal_html .= $cat=="gallery" ? '<div style="display:block !important;margin-bottom: 10px"><a href="'.home_url().'/people/'.$id.'/'.sanitize_title_with_dashes($person->name).'/"><< '.$person->name.'</a></div>' : "";
			foreach ( $img->img as $k => $i ) {
				$count= $k+1;
				$img_tags = $this->get_img_tags($i->img_id);
				$gal_html .= '<div class="gp-gallery-item">
								<a href="'.$this->img_converter($i).'" class="flipLightBox2">
									<img src="' . $this->img_converter( $i, 'thumb' ) . '"  alt="flipLightBox Image '.$count.'"/>
									<span>'.$img_tags->titles.$img_tags->people.$img_tags->chars.'</span>
								  </a>
							</div>';
				if($k==4 && $cat==""){
					$gal_html .= '<div class="spacer" style="clear: both;"></div><div style="display:block !important;"><a href="'.home_url().'/people/'.$id.'/'.sanitize_title_with_dashes($person->name).'/gallery">>> '.$this->translate('Gallery').'</a></div>';
					break;
				}

			}

			$gal_html .= '</div>';
			$gal_html .= '<div class="spacer" style="clear: both;"></div><hr/>';

		}

		// Gameography
		$gp = $this->gameography($id);
		$gp_html = "";
		if($gp!="" && $cat == ""){
			$gp_html .= '<div class="gp-gp"><div class="gp-gp-title">'.$this->translate('Gameography').'</div>';
			usort($gp, function($a, $b) {
				return $b->year - $a->year;
			});
			foreach ($gp as $k => $g) {
				$bg = $k%2==0 ? ' gp-color' : "";
				$gp_html .= '<div class="gp-gp-item'.$bg.'">';
					$gp_html .= '<div class="gp-gp-cover"><img src="' . $g->cover . '"/></div>';
					$gp_html .= '<div class="gp-gp-content">' . $g->game . '<br/>' . ( $g->char != "" ? str_replace('{x}',$g->char,$this->translate('as {x}')).($g->job!="" ? ' ('.$this->translate('Jobs').': '.$g->job.')': "") : ($g->job !="" ? $this->translate('Jobs').': ' . $g->job : "") ) . '</div>';
				$gp_html .= '</div>';
			}
			$gp_html .= '</div>';
		}


		// Game info template
		$template_url = GPRESS_URL . 'includes/frontend/templates/'.$template.'/';
		$temp = $this->html_get_contents($template_url.'person_info.html'); // fetch template
		$person_blank = GPRESS_URL.'includes/images/person_blank.png';

		// Template replaces
		$temp = str_replace('{photo}', $photo,$temp);
		$temp = str_replace('{person_blank}', $person_blank,$temp);
		$temp = str_replace('{template_url}', $template_url,$temp);
		$temp = str_replace('{cover_big_tag}', $cover_big_tag->titles.$cover_big_tag->people.$cover_big_tag->chars,$temp);
		$temp = str_replace('{gallery}', $gal_html,$temp);
		$temp = str_replace('{gameography}', $gp_html,$temp);
		$temp = str_replace('{birthday}', $bd,$temp);
		$temp = str_replace('{birth}', $birth,$temp);
		$temp = str_replace('{died}', $dd,$temp);
		$temp = str_replace('{bio}', $this->quote_esc($bio),$temp);
		$temp = str_replace('{zodiac}', $zodiac,$temp);
		$temp = str_replace('{name}', $this->quote_esc($person->name),$temp);
		$temp = str_replace('{realname}', $this->quote_esc($real),$temp);
		$temp = str_replace('{aka}', $this->quote_esc($aka),$temp);
		$temp = str_replace("{next}",$this->translate('Next'), $temp); // lang replaces
		$temp = str_replace("{back}",$this->translate('Back'), $temp); // lang replaces


		return $temp;
	}

	function gameography($id){
		global $wpdb;
		$id = absint($id);
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_crew WHERE person_id='.$id);
		$gp = array();
		$gameography = "";
		if(count($result)>0){

			foreach ($result as $k => $r){

				$game = $this->get_game($r->game_id);
				$gamelink = '<a href="'.home_url().'/games/'.$r->game_id.'/'.sanitize_title_with_dashes($game->title).'">'.$game->title.($game->year>0 ? ' ('.$game->year.')' : '').'</a>';
				$gp[$r->game_id]['game'] = $gamelink;
				$img = $this->get_game_image($r->game_id);
				$gameimg = $this->img_converter($img->main,"med", "cover");
				$gp[$r->game_id]['cover'] = $gameimg;
				$char = $r->char_id>0 ? '<a href="'.home_url().'/characters/'.$r->char_id.'/'.sanitize_title_with_dashes($r->char_name).'">'.$this->translate($r->char_name).'</a>' : $this->translate($r->char_name);
				$gp[$r->game_id]['char'] .= is_null($gp[$r->game_id]['char'])  ? $char : ($gp[$r->game_id]['char'] =="" ? $char : ' | '.$char);
				$gp[$r->game_id]['year'] = $game->year;
				$job = $this->get_job($r->job_id);
				if($r->job_id!=5 && $r->job_id!=6 ) {
					$gp[ $r->game_id ]['job'] .= $gp[ $r->game_id ]['job'] == "" ? $this->translate($job) : ( $job != "" ? " | " . $this->translate($job) : $this->translate($job) );
				}
			}
			$gp2 = array();
			 $xx = 0;
			foreach ($gp as $k => $g){
				$gp2[$xx] = $g;
				$xx++;
			}


			$gp_json = json_encode($gp2);
			$gameography = json_decode($gp_json);
		}

		return $gameography;

	}

	function add_person(){
		if(isset($_POST['p_name'])){
			$id = $this->insert_person();
			print('<script>window.location.href="admin.php?page=gp-people&id='.$id.'&added=added"</script>');
		}
		$photo = GPRESS_URL.'includes/images/nophoto.png';
		$arr_zodiac = array(
			'Aries',
			'Taurus',
			'Gemini',
			'Cancer',
			'Leo',
			'Virgo',
			'Libra',
			'Scorpio',
			'Sagittarius',
			'Capricorn',
			'Aquarius',
			'Pisces'
		);
		$temp = $this->html_get_contents( GPRESS_URL . 'includes/admin/pages/person.html' );
		$temp = str_replace( '{name:lang}', $this->translate( 'Name' ), $temp );
		$temp = str_replace( '{realname:lang}', $this->translate( 'Real Name' ), $temp );
		$temp = str_replace( '{aka:lang}', $this->translate( 'AKA' ), $temp );
		$temp = str_replace( '{photo:lang}', $this->translate( 'Photograph' ), $temp );
		$temp = str_replace( '{birthplace:lang}', $this->translate( 'Birthplace' ), $temp );
		$temp = str_replace( '{birthday:lang}', $this->translate( 'Birthday' ), $temp );
		$temp = str_replace( '{deathday:lang}', $this->translate( 'Died' ), $temp );
		$temp = str_replace( '{zodiac:lang}', $this->translate( 'Zodiac' ), $temp );
		$temp = str_replace( '{bio:lang}', $this->translate( 'Biography' ), $temp );
		$temp = str_replace( '{submit-button}', $this->translate( 'Add' ), $temp );
		$temp = str_replace( '{up-photo:lang}', $this->translate( 'Upload a photo' ), $temp );
		$temp = str_replace( '{return:lang}', $this->translate( 'Return to people' ), $temp );
		$temp = str_replace( '{return-url}', admin_url('admin.php?page=gp-people'), $temp );
		$zodiacs = '<option value="" selected>' . $this->translate( 'Select a zodiac' ) . '</option>';
		foreach ( $arr_zodiac as $z ) {
			$zodiacs .= '<option value="' . $z . '">' . $this->translate( $z ) . '</option>';
		}
		$temp = str_replace( '{zodiac}', $zodiacs, $temp );


		// Edit values
		$temp = str_replace( '{name}', '', $temp );
		$temp = str_replace( '{links}', '', $temp );
		$temp = str_replace( '{realname}', '', $temp );
		$temp = str_replace( '{aka}', '', $temp );
		$temp = str_replace( '{birthplace}', '', $temp );
		$temp = str_replace( '{birthday}', '', $temp );
		$temp = str_replace( '{deathday}', '', $temp );
		$temp = str_replace( '{bio}', '', $temp );
		$temp = str_replace( '{photo}', $photo, $temp );
		$temp = str_replace( '{id}', '', $temp );


		echo $temp;
    }

    function insert_person(){
	    global $wpdb;
	    $id="";
	    if(isset( $_POST['p_name'])){
		    @$name = sanitize_text_field(trim($_POST['p_name']));
		    @$real = sanitize_text_field(trim($_POST['p_real']));
		    @$bio = sanitize_textarea_field(trim($_POST['p_bio']));
		    @$zodiac = sanitize_text_field(trim($_POST['p_zodiac']));
		    @$aka = sanitize_text_field(trim($_POST['p_aka']));
		    @$bplace = sanitize_text_field(trim($_POST['p_bp']));
		    @$bday = sanitize_text_field(trim($_POST['p_bday']));
		    @$dday = sanitize_text_field(trim($_POST['p_dday']));
		    $wpdb->insert(
			    $wpdb->prefix.'gpress_people',
			    array(
				    'name' => $name,
				    'bio' => $bio,
				    'aka' => $aka,
				    'real_name' => $real,
				    'zodiac' => $zodiac,
				    'birthplace' => $bplace,
				    'birthday' => $bday,
				    'deathday' => $dday

			    )
		    );
		    $id = $wpdb->insert_id;
		    @$p_source=$_FILES['person_file']['tmp_name'];
		    @$filetype=$_FILES['person_file']['type'];
		    @$pos = strpos($filetype,'image');
		    if($pos !== false){
			    $date = new DateTime();
			    $uzanti = '.jpg';
			    $img_name= sha1($date->format('Y-m-d-H-i-s')."-".microtime());

			    $cr_folder = $this->create_img_file();
			    $folder = $cr_folder['folder'];
			    $image = $folder.$img_name.$uzanti;
			    $big = $folder.$img_name.'_big'.$uzanti;
			    $med = $folder.$img_name.'_med'.$uzanti;
			    $thumb =  $folder.$img_name.'_thumb'.$uzanti;
			    if(move_uploaded_file($p_source, $image)) {
				    if($_FILES['person_file']['type']=="image/png"){
					    $this->png2jpg($image,$image,100);
				    };
				    if($_FILES['person_file']['type']=="image/gif"){
					    $this->gif2jpg($image,$image,100);
				    }

				    $this->image_size( $image, $big, 270);
				    $this->image_size( $image, $med, 100);
				    $this->image_crop( $image, $thumb, 180, 180);
			    }

			    $save_folder = $cr_folder['file'];
			    $boyut= getimagesize($image);
			    $byt=$boyut[0]."x".$boyut[1];
			    $filesize=filesize($image);
			    $wpdb->insert(
				    $wpdb->prefix.'gpress_images',
				    array(
					    'name' => $img_name,
					    'img_size' => $byt,
					    'file_size' => $filesize,
					    'file' => $save_folder,
					    'file_type' => $uzanti,
					    'type' => 'profil'
				    )
			    );
			    $last_id = $wpdb->insert_id;


			    $wpdb->insert(
				    $wpdb->prefix.'gpress_content_images',
				    array(
					    'img_id' => absint($last_id),
					    'img_name' => $img_name,
					    'img_size' => $byt,
					    'file' => $save_folder,
					    'file_type' => $uzanti,
					    'type' => 'profil',
					    'content_id'=> absint($id),
					    'content_type' => "person",
					    'is_main' => absint(1)
				    )
			    );


		    }


        }
	    return $id;
    }


	function edit_person($id){
		if(@$_GET['p_gallery']!="edit") {
			if ( isset( $_POST['p_name'] ) ) {
				$this->update_person();
				?>
				<div class="updated notice">
					<p><?php echo $this->quote_esc($_POST['p_name']) ?> <?php echo $this->translate(  'has been updated.' ) ?></p>
				</div>
				<?php
			}
			$person = $this->get_person( $id );
			$photo = $this->get_main_img( $id, 'person' );
			$arr_zodiac = array(
				'Aries',
				'Taurus',
				'Gemini',
				'Cancer',
				'Leo',
				'Virgo',
				'Libra',
				'Scorpio',
				'Sagittarius',
				'Capricorn',
				'Aquarius',
				'Pisces'
			);
			$temp = $this->html_get_contents( GPRESS_URL . 'includes/admin/pages/person.html' );

			$fp = '<p>';
			$fp .= '<a href="'.home_url('people/'.$id.'/'.sanitize_title_with_dashes($person->name)).'" target="_blank">'.$this->translate('View the content').'</a>';
			$fp .= '&nbsp;&nbsp;&nbsp;<a href="'.admin_url('admin.php?page=gp-people&id='.$id.'&cat=gallery').'">'.$this->translate('Edit Gallery').'</a>';
			$fp .= '</p>';



			$temp = str_replace('{links}',$fp,$temp);
			$temp = str_replace( '{name:lang}', $this->translate( 'Name' ), $temp );
			$temp = str_replace( '{realname:lang}', $this->translate( 'Real Name' ), $temp );
			$temp = str_replace( '{aka:lang}', $this->translate( 'AKA' ), $temp );
			$temp = str_replace( '{photo:lang}', $this->translate( 'Photograph' ), $temp );
			$temp = str_replace( '{birthplace:lang}', $this->translate( 'Birthplace' ), $temp );
			$temp = str_replace( '{birthday:lang}', $this->translate( 'Birthday' ), $temp );
			$temp = str_replace( '{deathday:lang}', $this->translate( 'Died' ), $temp );
			$temp = str_replace( '{zodiac:lang}', $this->translate( 'Zodiac' ), $temp );
			$temp = str_replace( '{bio:lang}', $this->translate( 'Biography' ), $temp );
			$temp = str_replace( '{submit-button}', $this->translate( 'Save Changes' ), $temp );
			$temp = str_replace( '{up-photo:lang}', $this->translate( 'Upload a photo' ), $temp );
			$temp = str_replace( '{return:lang}', $this->translate( 'Return to people' ), $temp );
			$temp = str_replace( '{return-url}', admin_url('admin.php?page=gp-people'), $temp );
			$zodiacs = '<option value="" ' . ( $person->zodiac == "" ? "selected" : "" ) . '>' . $this->translate( 'Select a zodiac' ) . '</option>';
			foreach ( $arr_zodiac as $z ) {
				$zodiacs .= '<option value="' . $z . '" ' . ( $z == $person->zodiac ? "selected" : "" ) . '>' . $this->translate( $z ) . '</option>';
			}
			$temp = str_replace( '{zodiac}', $zodiacs, $temp );


			// Edit values
			$temp = str_replace( '{name}', $this->quote_esc($person->name), $temp );
			$temp = str_replace( '{realname}', $this->quote_esc($person->real_name), $temp );
			$temp = str_replace( '{aka}', $this->quote_esc($person->aka), $temp );
			$temp = str_replace( '{birthplace}', $this->quote_esc($person->birthplace), $temp );
			$temp = str_replace( '{birthday}', $person->birthday, $temp );
			$temp = str_replace( '{deathday}', $person->deathday, $temp );
			$temp = str_replace( '{bio}', $this->quote_esc($person->bio), $temp );
			$temp = str_replace( '{photo}', $photo, $temp );
			$temp = str_replace( '{id}', $id, $temp );


			echo $temp;
			if(@$_GET['added']=="added"){
				?>
                <div class="updated notice">
                    <p><?php echo $person->name.' '.$this->translate('has been added.')?></p>
                </div>
				<?php
			}
		}
	}


	function update_person(){
		global $wpdb;
		if(isset($_POST['p_name'])){

			@$name = $this->quote_slash(sanitize_text_field(trim(htmlspecialchars($_POST['p_name'], ENT_QUOTES))));
			@$real = $this->quote_slash(sanitize_text_field(trim(htmlspecialchars($_POST['p_real'], ENT_QUOTES))));
			@$bio = sanitize_textarea_field(trim($_POST['p_bio']));
			@$zodiac = sanitize_text_field(trim($_POST['p_zodiac']));
			@$aka = sanitize_text_field(trim($_POST['p_aka']));
			@$bplace = sanitize_text_field(trim($_POST['p_bp']));
			@$bday = sanitize_text_field(trim($_POST['p_bday']));
			@$dday = sanitize_text_field(trim($_POST['p_dday']));
			@$id = sanitize_text_field(trim($_POST['p_id']));

			$wpdb->update(
				$wpdb->prefix.'gpress_people',
				array(
					'name' => $name,
					'bio' => $bio,
					'aka' => $aka,
					'real_name' => $real,
					'zodiac' => $zodiac,
					'birthplace' => $bplace,
					'birthday' => $bday,
					'deathday' => $dday

				),
				array(
					'id'=> absint($id)
				)
			);

			@$p_source=$_FILES['person_file']['tmp_name'];
			@$filetype=$_FILES['person_file']['type'];
			@$pos = strpos($filetype,'image');
			if($pos !== false){
				$date = new DateTime();
				$uzanti = '.jpg';
				$img_name= sha1($date->format('Y-m-d-H-i-s')."-".microtime());

				$cr_folder = $this->create_img_file();
				$folder = $cr_folder['folder'];
				$image = $folder.$img_name.$uzanti;
				$big = $folder.$img_name.'_big'.$uzanti;
				$med = $folder.$img_name.'_med'.$uzanti;
				$thumb =  $folder.$img_name.'_thumb'.$uzanti;
				if(move_uploaded_file($p_source, $image)) {
					if($_FILES['person_file']['type']=="image/png"){
						$this->png2jpg($image,$image,100);
					};
					if($_FILES['person_file']['type']=="image/gif"){
						$this->gif2jpg($image,$image,100);
					}

					$this->image_size( $image, $big, 270);
					$this->image_size( $image, $med, 100);
					$this->image_crop( $image, $thumb, 180, 180);
				}

				$save_folder = $cr_folder['file'];
				$boyut= getimagesize($image);
				$byt=$boyut[0]."x".$boyut[1];
				$filesize=filesize($image);
				$wpdb->insert(
					$wpdb->prefix.'gpress_images',
					array(
						'name' => $img_name,
						'img_size' => $byt,
						'file_size' => $filesize,
						'file' => $save_folder,
						'file_type' => $uzanti,
						'type' => 'profil'
					)
				);
				$last_id = $wpdb->insert_id;

				$wpdb->update(
					$wpdb->prefix.'gpress_content_images',
					array(
						'is_main' => 0,

					),
					array(
						'content_id'=> absint($id),
						'content_type' => "person",
						'is_main' => 1
					)
				);

				$wpdb->insert(
					$wpdb->prefix.'gpress_content_images',
					array(
						'img_id' => absint($last_id),
						'img_name' => $img_name,
						'img_size' => $byt,
						'file' => $save_folder,
						'file_type' => $uzanti,
						'type' => 'profil',
						'content_id'=> absint($id),
						'content_type' => "person",
						'is_main' => absint(1)
					)
				);


			}


		}
	}



	// Game gallery
	function gallery($id){
		if(isset($_POST['upload_pics'])){
			$this->upload_all_images($id,'person','gallery_files');
			?>
            <div class="updated notice">
                <p><?php echo $this->translate(  'Pictures has been uploaded.' ) ?></p>
            </div>
			<?php

		}
		$this->gallery_action($id);
		$img = $this->get_game_image($id,"person");

		?>
        <script type="text/javascript">
            jQuery(document).ready(function () {
                $("select#gp-game-gallery").imagepicker({
                    hide_select:  true,
                });

                var container = $("select.image-picker.masonry").next("ul.thumbnails");
                container.imagesLoaded(function(){
                    container.masonry({
                        itemSelector:   "li",
                    });
                });


                $("form").submit(function() {
                    if ($('input.action-gallery').val() == "<?php echo $this->translate("Apply")?>") {
                        if($('#action-time').val()=="delete") {
                            var c = confirm("<?php echo $this->translate('Are you sure?')?>");
                            return c;
                        }
                    }
                });



            });

        </script>

        <div class="game-op" style="top: 5px;position: relative;padding:30px">
            <form method="post" action="" enctype="multipart/form-data">
                <div style="display: block">
                    <div style="float: left;">
                        <select  name="action_sel" id="action-time">
                            <option value=""><?php echo $this->translate('Action')?></option>
                            <option value="cover"><?php echo $this->translate('Make Profile Photo')?></option>
                            <option value="go"><?php echo $this->translate('Edit Picture')?></option>
                            <option value="delete"><?php echo $this->translate('Delete')?></option>
                        </select>
                        <input type="submit" value="<?php echo $this->translate('Apply')?>" name="gallery_action" class="button button-primary action-gallery">

                    </div>
                    <div style="float: right;position: relative;margin-right: 150px">
                        <div class="upload-btn-wrapper">
                            <button class="btn"><?php echo "&#x2191; ".$this->translate('Upload Pictures')?></button>
                            <input type="file" name="gallery_files[]" multiple="multiple"/>

                        </div>
                        <input type="submit" value="<?php echo $this->translate('Save')?>" name="upload_pics" class="btn button button-primary" style="height: 35px">
                    </div>

                </div>
                <br/><br/><br/>
				<?php

				echo '<select class="image-picker masonry show-html" id="gp-game-gallery" name="gp_gallery">';
				echo '<option value=""></option>';
				if($img!="") {
					echo( isset( $img->main ) ? '<option data-img-src="' . $this->img_converter( $img->main, 'big' ) . '" value="' . $img->main->img_id . '" selected="selected">' . $img->main->img_id . '</option>' : '' );
					if(isset($img->img)){
						foreach ($img->img as $i){
							echo '<option data-img-src="' . $this->img_converter( $i, 'big' ) . '" value="' . $i->img_id . '">' . $i->img_id . '</option>';
						}
					}
				}
				echo '</select>';
				?>
            </form>
        </div>
		<?php

	}


	function gallery_action($id){
		global $wpdb;
		if(isset($_POST['gallery_action'])){

			// Cover
			if(@$_POST['action_sel'] == "cover"){
				if(@$_POST['gp_gallery'] != ""){

					@$img = absint($_POST['gp_gallery']);
					$wpdb->update(
						$wpdb->prefix.'gpress_content_images',
						array(
							'is_main' => 0,

						),
						array(
							'content_id'=> absint($id),
							'content_type' => "person",
							'is_main' => 1
						)
					);
					$wpdb->update(
						$wpdb->prefix.'gpress_content_images',
						array(
							'is_main' => 1,

						),
						array(
							'content_id'=> absint($id),
							'content_type' => "person",
							'img_id' => $img
						)
					);

					?>
                    <div class="updated notice">
                        <p><?php echo $this->translate(  'The profile photo has been changed.' ) ?></p>
                    </div>
					<?php
				}
			}else if(@$_POST['action_sel'] == "delete"){
				@$img = absint($_POST['gp_gallery']);
				$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_images WHERE id='.$img);
				if(count($result)>0){
					foreach ($result as $r){
						$check = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_content_images WHERE is_main=1 AND img_id='.$r->id);
						if(count($check) == 0) {
							$org   = GPRESS_IMG_DIR . DIRECTORY_SEPARATOR . str_replace( '/', DIRECTORY_SEPARATOR, $r->file ) . $r->name . $r->file_type;
							$big   = GPRESS_IMG_DIR . DIRECTORY_SEPARATOR . str_replace( '/', DIRECTORY_SEPARATOR, $r->file ) . $r->name . "_big" . $r->file_type;
							$med   = GPRESS_IMG_DIR . DIRECTORY_SEPARATOR . str_replace( '/', DIRECTORY_SEPARATOR, $r->file ) . $r->name . "_med" . $r->file_type;
							$thumb = GPRESS_IMG_DIR . DIRECTORY_SEPARATOR . str_replace( '/', DIRECTORY_SEPARATOR, $r->file ) . $r->name . "_thumb" . $r->file_type;
							wp_delete_file( $org );
							wp_delete_file( $big );
							wp_delete_file( $med );
							wp_delete_file( $thumb );
							$wpdb->delete(
								"{$wpdb->prefix}gpress_images",
								array( 'id' => $r->id ),
								array( '%d' )
							);
							$wpdb->delete(
								"{$wpdb->prefix}gpress_content_images",
								array( 'img_id' => $r->id ),
								array( '%d' )
							);
							?>
                            <div class="updated notice">
                                <p><?php echo $this->translate( 'The picture has been deleted.' ) ?></p>
                            </div>
							<?php
						}else{
							?>
                            <div class="error notice">
                                <p><?php echo $this->translate( 'The profile photos cannot be deleted.' ) ?></p>
                            </div>
							<?php
						}

					}
				}
			}else if(@$_POST['action_sel']=="go"){
				@$img = absint($_POST['gp_gallery']);
				if(@$_POST['gp_gallery']!="") {
					print( '<script>window.location.href="admin.php?page=gp-gallery&id=' . $img . '"</script>' );

				}
			}

			//


		}

	}



}