<?php
// Redirect activated plugin
add_action( 'activated_plugin', 'gpress_install_activation' );

// Add action of shortcodes
add_action('init', 'gpress_register_shortcodes');

// Add action of redirects
add_action('init', 'custom_gpress_rule');

// Add action of frontend css
add_action('wp_enqueue_scripts','gpress_frontend_styles');
// Add action of admin css
add_action('admin_enqueue_scripts','gpress_admin_styles');
add_action('admin_enqueue_scripts','gpress_admin_selectize_styles');
add_action('admin_enqueue_scripts','gpress_admin_img_picker_styles');



// Add action of js
      /* ==Frontend */
add_action('wp_enqueue_scripts','gp_gpress_frontend_scripts');
      /* ==Admin */
add_action('admin_footer','gp_gpress_admin_jquery_scripts');
add_action('admin_footer','gp_gpress_admin_selectize_scripts');
add_action('admin_footer','gp_gpress_admin_mason_scripts');
add_action('admin_footer','gp_gpress_admin_img_picker_scripts');


// Header
add_action('wp_footer', 'gpress_174099_append_to_content');

function gpress_174099_append_to_content() {
	//get your data
	$page = get_page_by_path('games');
	if(is_page($page->ID)){
		@$id = get_query_var('game_id');
		if($id != ""){
			$game = new gpress_game_detail_queries();
			$temp = $game->get_full_temp();
			$gm     = $game->get_game_image( $id );
			$header = $game->select_header( $gm->img );
			if($temp->header==1) {
				$header = $header=="" ? GPRESS_URL . 'includes/images/noheader.jpg' : $header;
				?>
				<script type="text/javascript">
                    jQuery('body').prepend('<div id="gp_header" style="background: url(<?php echo $header?>) no-repeat center center; background-size:cover;width: 100%;height: 500px;top:0;position: absolute; z-index:-10 !important;"></div>');

				</script>
				<?php

			}
			if($temp->para == 1){
				?>
				<script type="text/javascript">
                    if ($(window).width() > 600) {
                        $('#gp_header').parallax({imageSrc: '<?php echo $header?>', zIndex: <?php echo $temp->zindex?>});
                    }
				</script>
				<?php
			}


		}
	}

	//always return when using a filter

}



// Admin menu
// Add admin menu
add_action('admin_menu','gp_gpress_menus');


// rewrite rules
function custom_gpress_rule() {
	/********** GAMES PAGE *************/
	//Tags
	add_rewrite_tag('%game_id%', '([^&]+)', 'game_id=');
	add_rewrite_tag('%game_title%', '([^&]+)', 'game_title=');
	add_rewrite_tag('%game_cat%', '([^&]+)', 'game_cat=');
	add_rewrite_tag('%game_p%', '([^&]+)', 'game_p=');
	//Rules
	add_rewrite_rule('^games/([^/]*)/([^/]*)/([^/]*)/?','index.php?pagename=games&game_id=$matches[1]&game_title=$matches[2]&game_cat=$matches[3]','top');
	add_rewrite_rule('^games/([^/]*)/([^/]*)/?','index.php?pagename=games&game_id=$matches[1]&game_title=$matches[2]','top');
	add_rewrite_rule('^games/page-([^/]*)/?','index.php?pagename=games&game_p=$matches[1]','top');

	/********** PEOPLE PAGE *************/
	// Tags
	add_rewrite_tag('%person_id%', '([^&]+)', 'person_id=');
	add_rewrite_tag('%person_name%', '([^&]+)', 'person_name=');
	add_rewrite_tag('%person_cat%', '([^&]+)', 'person_cat=');
	add_rewrite_tag('%person_p%', '([^&]+)', 'person_p=');
	//Rules
	add_rewrite_rule('^people/([^/]*)/([^/]*)/([^/]*)/?','index.php?pagename=people&person_id=$matches[1]&person_name=$matches[2]&person_cat=$matches[3]','top');
	add_rewrite_rule('^people/([^/]*)/([^/]*)/?','index.php?pagename=people&person_id=$matches[1]&person_name=$matches[2]','top');
	add_rewrite_rule('^people/page-([^/]*)/?','index.php?pagename=people&person_p=$matches[1]','top');

	/********** CHARACTERS PAGE *************/
	//Tags
	add_rewrite_tag('%char_id%', '([^&]+)', 'char_id=');
	add_rewrite_tag('%char_name%', '([^&]+)', 'char_name=');
	add_rewrite_tag('%char_cat%', '([^&]+)', 'char_cat=');
	add_rewrite_tag('%char_p%', '([^&]+)', 'char_p=');
	//Rules
	add_rewrite_rule('^characters/([^/]*)/([^/]*)/([^/]*)/?','index.php?pagename=characters&char_id=$matches[1]&char_name=$matches[2]&char_cat=$matches[3]','top');
	add_rewrite_rule('^characters/([^/]*)/([^/]*)/?','index.php?pagename=characters&char_id=$matches[1]&char_name=$matches[2]','top');
	add_rewrite_rule('^characters/page-([^/]*)/?','index.php?pagename=characters&char_p=$matches[1]','top');

	/********** THEMES PAGE *************/
	//Tags
	add_rewrite_tag('%theme_id%', '([^&]+)', 'theme_id=');
	add_rewrite_tag('%theme_name%', '([^&]+)', 'theme_name=');
	add_rewrite_tag('%theme_p%', '([^&]+)', 'theme_p=');
	//Rules
	add_rewrite_rule('^themes/([^/]*)/([^/]*)/([^/]*)/?','index.php?pagename=themes&theme_id=$matches[1]&theme_name=$matches[2]&theme_p=$matches[3]','top');
	add_rewrite_rule('^themes/([^/]*)/([^/]*)/?','index.php?pagename=themes&theme_id=$matches[1]&theme_name=$matches[2]','top');

	/********** GENRES PAGE *************/
	//Tags
	add_rewrite_tag('%genre_id%', '([^&]+)', 'genre_id=');
	add_rewrite_tag('%genre_name%', '([^&]+)', 'genre_name=');
	add_rewrite_tag('%genre_p%', '([^&]+)', 'genre_p=');
	//Rules
	add_rewrite_rule('^genres/([^/]*)/([^/]*)/([^/]*)/?','index.php?pagename=genres&genre_id=$matches[1]&genre_name=$matches[2]&genre_p=$matches[3]','top');
	add_rewrite_rule('^genres/([^/]*)/([^/]*)/?','index.php?pagename=genres&genre_id=$matches[1]&genre_name=$matches[2]','top');

	/********** MODES PAGE *************/
	//Tags
	add_rewrite_tag('%mode_id%', '([^&]+)', 'mode_id=');
	add_rewrite_tag('%mode_name%', '([^&]+)', 'mode_name=');
	add_rewrite_tag('%mode_p%', '([^&]+)', 'mode_p=');
	//Rules
	add_rewrite_rule('^modes/([^/]*)/([^/]*)/([^/]*)/?','index.php?pagename=modes&mode_id=$matches[1]&mode_name=$matches[2]&mode_p=$matches[3]','top');
	add_rewrite_rule('^modes/([^/]*)/([^/]*)/?','index.php?pagename=modes&mode_id=$matches[1]&mode_name=$matches[2]','top');

	/********** PLATFORMS PAGE *************/
	//Tags
	add_rewrite_tag('%platform_id%', '([^&]+)', 'platform_id=');
	add_rewrite_tag('%platform_name%', '([^&]+)', 'platform_name=');
	add_rewrite_tag('%platform_p%', '([^&]+)', 'platform_p=');
	//Rules
	add_rewrite_rule('^platforms/([^/]*)/([^/]*)/([^/]*)/?','index.php?pagename=platforms&platform_id=$matches[1]&platform_name=$matches[2]&platform_p=$matches[3]','top');
	add_rewrite_rule('^platforms/([^/]*)/([^/]*)/?','index.php?pagename=platforms&platform_id=$matches[1]&platform_name=$matches[2]','top');

	/********** ENGINES PAGE *************/
	//Tags
	add_rewrite_tag('%engine_id%', '([^&]+)', 'engine_id=');
	add_rewrite_tag('%engine_name%', '([^&]+)', 'engine_name=');
	add_rewrite_tag('%engine_p%', '([^&]+)', 'engine_p=');
	//Rules
	add_rewrite_rule('^engines/([^/]*)/([^/]*)/([^/]*)/?','index.php?pagename=engines&engine_id=$matches[1]&engine_name=$matches[2]&engine_p=$matches[3]','top');
	add_rewrite_rule('^engines/([^/]*)/([^/]*)/?','index.php?pagename=engines&engine_id=$matches[1]&engine_name=$matches[2]','top');

	/********** PERSPECTIVES PAGE *************/
	//Tags
	add_rewrite_tag('%perspective_id%', '([^&]+)', 'perspective_id=');
	add_rewrite_tag('%perspective_name%', '([^&]+)', 'perspective_name=');
	add_rewrite_tag('%perspective_p%', '([^&]+)', 'perspective_p=');
	//Rules
	add_rewrite_rule('^perspectives/([^/]*)/([^/]*)/([^/]*)/?','index.php?pagename=perspectives&perspective_id=$matches[1]&perspective_name=$matches[2]&perspective_p=$matches[3]','top');
	add_rewrite_rule('^perspectives/([^/]*)/([^/]*)/?','index.php?pagename=perspectives&perspective_id=$matches[1]&perspective_name=$matches[2]','top');

	/********** COMPANIES PAGE *************/
	//Tags
	add_rewrite_tag('%comp_id%', '([^&]+)', 'comp_id=');
	add_rewrite_tag('%comp_name%', '([^&]+)', 'comp_name=');
	add_rewrite_tag('%comp_p%', '([^&]+)', 'comp_p=');
	//Rules
	add_rewrite_rule('^companies/([^/]*)/([^/]*)/([^/]*)/?','index.php?pagename=companies&comp_id=$matches[1]&comp_name=$matches[2]&comp_p=$matches[3]','top');
	add_rewrite_rule('^companies/([^/]*)/([^/]*)/?','index.php?pagename=companies&comp_id=$matches[1]&comp_name=$matches[2]','top');

}


//Meta tags

function gpress_setmeta_defs(){
	$gen = new gp_game_general_queries();
	@$game_id = get_query_var('game_id');
	@$person_id = get_query_var('person_id');
	@$char_id = get_query_var('char_id');
	@$comp_id = get_query_var('comp_id');
	if($game_id!=""){
		$game = gp_gpress_get_game_query();
		$cover = $gen->get_main_img($game_id,'title');
		$url = home_url('games/'.$game->id.'/'.sanitize_title_with_dashes($gen->quote_esc($game->title)).'/');
		$total_rating = round($gen->cal_rate(absint($game_id)));
		$total_rating = $total_rating != "" ? $total_rating/10 : 0;
		//Facebook
		echo '<meta property="og:title" content="'.esc_html($gen->quote_esc($game->title).($game->year>0 ? ' ('.$game->year.')': '')).'">';
		echo '<meta property="og:description" content="'.esc_html($gen->limit_the_text($gen->quote_esc($game->sum),40)).'">';
		echo '<meta property="og:image" content="'.$cover.'">';
		echo '<meta property="og:url" content="'.$url.'">';
		//Twitter
		echo '<meta property="twitter:title" content="'.esc_html($gen->quote_esc($game->title).($game->year>0 ? ' ('.$game->year.')': '')).'">';
		echo '<meta property="twitter:description" content="'.esc_html($gen->limit_the_text($gen->quote_esc($game->sum),40)).'">';
		echo '<meta property="twitter:image" content="'.$cover.'">';
		echo '<meta property="twitter:url" content="'.$url.'">';
		//Google
		echo '<meta property="name" content="'.esc_html($gen->quote_esc($game->title).($game->year>0 ? ' ('.$game->year.')': '')).'">';
		echo '<meta property="description" content="'.esc_html($gen->limit_the_text($gen->quote_esc($game->sum),40)).'">';
		echo '<meta property="image" content="'.$cover.'">';
		//Rich snipnets
        $snip = '<script type="application/ld+json"> { "@context" : "http://schema.org", "@type" : "Article", "name" : "'.esc_html($gen->quote_esc($game->title).($game->year>0 ? ' ('.$game->year.')': '')).'", "image" : "'.$cover.'", "articleSection" : "'.esc_html($gen->limit_the_text($gen->quote_esc($game->sum),40)).'", "aggregateRating" : { "@type" : "AggregateRating", "ratingValue" : "'.$total_rating.'" } } </script>';
        echo $snip;

	}else if($person_id!=""){
		$person = gp_gpress_get_person_query();
		$cover = $gen->get_main_img($game_id,'person');
		$url = home_url('people/'.$person->id.'/'.sanitize_title_with_dashes($gen->quote_esc($person->name)).'/');
		//Facebook
		echo '<meta property="og:title" content="'.esc_html($gen->quote_esc($person->name)).'">';
		echo '<meta property="og:description" content="'.esc_html($gen->limit_the_text($gen->quote_esc($person->bio),40)).'">';
		echo '<meta property="og:image" content="'.$cover.'">';
		echo '<meta property="og:image:width" content="150">';
		echo '<meta property="og:url" content="'.$url.'">';
		//Twitter
		echo '<meta property="twitter:title" content="'.esc_html($gen->quote_esc($person->name)).'">';
		echo '<meta property="twitter:description" content="'.esc_html($gen->limit_the_text($gen->quote_esc($person->bio),40)).'">';
		echo '<meta property="twitter:image" content="'.esc_url($cover).'">';
		echo '<meta property="twitter:url" content="'.$url.'">';
		//Google
		echo '<meta property="name" content="'.esc_html($gen->quote_esc($person->name)).'">';
		echo '<meta property="description" content="'.esc_html($gen->limit_the_text($gen->quote_esc($person->bio),40)).'">';
		echo '<meta property="image" content="'.$cover.'">';
		//Rich snipnets
		$snip = '<script type="application/ld+json"> { "@context" : "http://schema.org", "@type" : "Article", "name" : "'.esc_html($gen->quote_esc($person->name)).'", "image" : "'.$cover.'", "articleSection" : "'.esc_html($gen->limit_the_text($gen->quote_esc($person->bio),40)).'" } </script>';
		echo $snip;
	}else if($char_id!=""){
		$char = gp_gpress_get_char_query();
		$cover = $gen->get_main_img($game_id,'char');
		$url = home_url('characters/'.$char->id.'/'.sanitize_title_with_dashes($gen->quote_esc($char->name)).'/');
		//Facebook
		echo '<meta property="og:title" content="'.esc_html($gen->quote_esc($char->name)).'">';
		echo '<meta property="og:description" content="'.esc_html($gen->limit_the_text($gen->quote_esc($char->sum),40)).'">';
		echo '<meta property="og:image" content="'.$cover.'">';
		echo '<meta property="og:image:width" content="150">';
		echo '<meta property="og:url" content="'.$url.'">';
		//Twitter
		echo '<meta property="twitter:title" content="'.esc_html($gen->quote_esc($char->name)).'">';
		echo '<meta property="twitter:description" content="'.esc_html($gen->limit_the_text($gen->quote_esc($char->sum),40)).'">';
		echo '<meta property="twitter:image" content="'.esc_url($cover).'">';
		echo '<meta property="twitter:url" content="'.$url.'">';
		//Google
		echo '<meta property="name" content="'.esc_html($gen->quote_esc($char->name)).'">';
		echo '<meta property="description" content="'.esc_html($gen->limit_the_text($gen->quote_esc($char->sum),40)).'">';
		echo '<meta property="image" content="'.$cover.'">';
		//Rich snipnets
		$snip = '<script type="application/ld+json"> { "@context" : "http://schema.org", "@type" : "Article", "name" : "'.esc_html($gen->quote_esc($char->name)).'", "image" : "'.$cover.'", "articleSection" : "'.esc_html($gen->limit_the_text($gen->quote_esc($char->sum),40)).'" } </script>';
		echo $snip;
	}else if($comp_id!=""){
		$comp = new gpress_game_comps_queries();
		$com = $comp->get_comp($comp_id);
		$url = home_url('companies/'.$com->id.'/'.sanitize_title_with_dashes($gen->quote_esc($com->name)).'/');
		$logo = $com->logo !="" ? GPRESS_URL.'includes/'.$com->logo : GPRESS_URL.'includes/images/nologo.jpg';
		//Facebook
		echo '<meta property="og:title" content="'.esc_html($gen->quote_esc($com->name)).'">';
		echo '<meta property="og:description" content="'.esc_html($gen->limit_the_text($gen->quote_esc($com->history),40)).'">';
		echo '<meta property="og:image" content="'.$logo.'">';
		echo '<meta property="og:image:width" content="300">';
		echo '<meta property="og:url" content="'.$url.'">';
		//Twitter
		echo '<meta property="twitter:title" content="'.esc_html($gen->quote_esc($com->name)).'">';
		echo '<meta property="twitter:description" content="'.esc_html($gen->limit_the_text($gen->quote_esc($com->history),40)).'">';
		echo '<meta property="twitter:image" content="'.esc_url($logo).'">';
		echo '<meta property="twitter:url" content="'.$url.'">';
		echo '<meta property="twitter:card" content="summary_large_image">';
		//Google
		echo '<meta property="name" content="'.esc_html($gen->quote_esc($com->name)).'">';
		echo '<meta property="description" content="'.esc_html($gen->limit_the_text($gen->quote_esc($com->history),40)).'">';
		echo '<meta property="image" content="'.$logo.'">';
		$snip = '<script type="application/ld+json"> { "@context" : "http://schema.org", "@type" : "Article", "name" : "'.esc_html($gen->quote_esc($com->name)).'", "image" : "'.$logo.'", "articleSection" : "'.esc_html($gen->limit_the_text($gen->quote_esc($com->history),40)).'" } </script>';
		echo $snip;
	}


}

add_action( 'wp_head', 'gpress_setmeta_defs' );



// Add rating js
function gp_rating_ajax_scripts() {
	// load our jquery file that sends the $.post request
	wp_enqueue_script( "my-ajax-handle", GPRESS_URL . 'includes/frontend/js/rate-star.js', array( 'jquery' ) );

	// make the ajaxurl var available to the above script
	wp_localize_script( 'my-ajax-handle', 'the_ajax_script', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
}
add_action('wp_enqueue_scripts', 'gp_rating_ajax_scripts');


// Add selectize js
function gp_selectize_ajax_scripts(){
	$sel = new gpress_selectize_queries();
	if((@$_GET['page']=="gp-companies")){
		$sel->sel_comp_script('comp_parents');
	}
	else if((@$_GET['page']=="gp-games") && (isset($_GET['id']))){
		$sel->sel_dev_script('dev_comp');
		$sel->sel_pub_script('pub_comp');
		$sel->sel_op_script('genre_op');
		$sel->sel_op_script('theme_op');
		$sel->sel_op_script('perv_op');
		$sel->sel_op_script('mode_op');
		$sel->sel_engine_script('engine_op');
		$sel->sel_plat_script('plat_op');
		$sel->sel_crew_script('crew_sel');
		$sel->sel_cast_person_script('person_sel');
		$sel->sel_cast_char_script('char_sel');

	}
	else if((@$_GET['page']=="gp-games") && ($_GET['add'] == "new")){
		$sel->sel_dev_script('dev_comp');
		$sel->sel_pub_script('pub_comp');
		$sel->sel_op_script('genre_op');
		$sel->sel_op_script('theme_op');
		$sel->sel_op_script('perv_op');
		$sel->sel_op_script('mode_op');
		$sel->sel_engine_script('engine_op');
		$sel->sel_plat_script('plat_op');

	}else if((@$_GET['page']=="gp-gallery") && (isset($_GET['id']))){
		$sel->sel_crew_script('person_sel');
		$sel->sel_cast_chars_script('chars_sel');
		$sel->sel_game_script('game_sel');
	}
}
add_action('admin_footer', 'gp_selectize_ajax_scripts');


// Add rating function

function gp_ajax_process_request() {
	global $wpdb;

	$user = absint(get_current_user_id());
	if(isset( $_POST["gp_rate"] ) ) {
		$content_id = absint($_POST['game_id']);
		$rating = $_POST["gp_rate"];
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_rating WHERE user='.$user.' AND content="title" AND content_id='.$content_id);
		if(count($result)>0){
			$wpdb->update(
				$wpdb->prefix.'gpress_rating',
				array(
					'rating' => $rating

				),
				array(
					'user' => $user,
					'content' => 'title',
					'content_id' => $content_id
				)
			);
		}else{
			$wpdb->insert(
				$wpdb->prefix.'gpress_rating',
				array(
					'user'    => $user,
					'content'   => 'title',
					'content_id' => $content_id,
					'rating' => $rating
				)
			);
		}


	}else if(isset( $_POST["gp_delete"] ) ){
		$wpdb->delete( $wpdb->prefix.'gpress_rating',
			array(
				'content_id' => absint($_POST['game_id']),
				'content' => 'title',
				'user' => $user
			) );
	}
}
add_action( 'wp_ajax_gp_action', 'gp_ajax_process_request');




// Add selectize function
function gp_ajax_selectize_request(){
	$comp = new gpress_game_comps_queries();
	$game = new gpress_game_detail_queries();
	if(isset($_POST['comp_key'])) {
		$comp->select_comp($_POST['comp_key']);
		wp_die();
	}
	if(isset($_POST['dev_key'])) {
		$comp->select_comp($_POST['dev_key']);
		wp_die();
	}
	if(isset($_POST['pub_key'])) {
		$comp->select_comp($_POST['pub_key']);
		wp_die();
	}
	if(isset($_POST['engine_key'])) {
		$game->select_op($_POST['engine_key'],'engines');
		wp_die();
	}
	if(isset($_POST['plat_key'])) {
		$game->select_op($_POST['plat_key'],'platforms');
		wp_die();
	}
	if(isset($_POST['crew_key'])) {
		$game->select_people($_POST['crew_key']);
		wp_die();
	}
	if(isset($_POST['cast_key'])) {
		$game->select_people($_POST['cast_key']);
		wp_die();
	}
	if(isset($_POST['char_key'])) {
		$game->select_char($_POST['char_key']);
		wp_die();
	}
	if(isset($_POST['chars_key'])) {
		$game->select_char($_POST['chars_key']);
		wp_die();
	}
	if(isset($_POST['game_key'])) {
		$game->select_game($_POST['game_key']);
		wp_die();
	}

}
add_action( 'wp_ajax_selectize_action', 'gp_ajax_selectize_request');